<?php
/**
 * This file implements the UI view for the Collection features properties.
 *
 * This file is part of the Quam Plures project - {@link http://quamplures.net/}.
 * See also {@link https://launchpad.net/quam-plures}.
 *
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}.
 *
 * @license http://quamplures.net/license.html GNU General Public License (GPL)
 *
 * {@internal Open Source relicensing agreement:
 * }}
 *
 * {@internal Below is a list of authors who have contributed to design/coding of this file: }}
 *
 * @package collections
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * @var Blog
 */
global $edited_Blog;

global $Plugins;

?>
<script type="text/javascript">
	<!--
	function show_hide_feedback_details(ob)
	{
		var fldset = document.getElementById( 'feedback_details_container' );
		if( ob.value == 'never' )
		{
			fldset.style.display = 'none';
		}
		else
		{
			fldset.style.display = '';
		}
	}
	//-->
</script>
<?php
$Form = new Form( NULL, 'coll_features_checkchanges' );

$Form->begin_form( 'fform' );

$Form->hidden_ctrl();
$Form->hidden( 'action', 'update' );
$Form->hidden( 'tab', 'features' );
$Form->hidden( 'blog', $edited_Blog->ID );

$Form->begin_fieldset( T_('Post options') );
	$Form->radio( 'require_title', $edited_Blog->get_setting( 'require_title' ), array(
		array( 'required', T_('Always'), T_('The blogger must provide a title') ),
		array( 'optional', T_('Optional'), T_('The blogger can leave the title field empty') ),
		array( 'none', T_('Never'), T_('No title field') )
	), T_('Post titles'), true );
	// FP> TODO:
	// -post_url: always('required')|optional|never
	// -multilingual: true|false or better yet: provide a list to narrow down the active locales
	// -tags always('required')|optional|never
$Form->end_fieldset();

$Form->begin_fieldset( T_('Feedback options') );
	$Form->radio( 'blog_allowcomments', $edited_Blog->get( 'allowcomments' ), array(
		array( 'always', T_('Allow on all posts'), T_('Always allow comments on every post'),
			'', 'onclick="show_hide_feedback_details(this);"'),
		array( 'post_by_post', T_('Can be disabled on a per post basis'), T_('Comments can be disabled on each post separatly'),
			'', 'onclick="show_hide_feedback_details(this);"'),
		array( 'never', T_('No comments are allowed in this blog'), T_('Never allow any comments in this blog'),
			'', 'onclick="show_hide_feedback_details(this);"')
	), T_('Comments'), true );

	echo '<div id="feedback_details_container">';
	$Form->radio( 'allow_rating', $edited_Blog->get_setting( 'allow_rating' ), array(
		array( 'always', T_('Always') ),
		array( 'never', T_('Never') ),
	), T_('Ratings'), true );
	$Form->checkbox( 'blog_allowtrackbacks', $edited_Blog->get( 'allowtrackbacks' ), T_('Trackbacks'), T_("Allow other bloggers to send trackbacks to this blog, letting you know when they refer to it. This will also let you send trackbacks to other blogs.") );

	$status_options = array(
		'draft'      => T_('Draft'),
		'published'  => T_('Published'),
		'deprecated' => T_('Deprecated')
	);
	$Form->select_input_array( 'new_feedback_status', $edited_Blog->get_setting( 'new_feedback_status' ), $status_options,
		T_('New feedback status'), T_('This status will be assigned to new comments/trackbacks from non moderators (unless overriden by plugins).') );
	echo '</div>';

	if( $edited_Blog->get( 'allowcomments' ) == 'never' )
	{ ?>
	<script type="text/javascript">
		<!--
		var fldset = document.getElementById( 'feedback_details_container' );
		fldset.style.display = 'none';
		//-->
	</script>
	<?php
	}
$Form->end_fieldset();

$Form->begin_fieldset( T_('RSS/Atom feeds') );
	$Form->radio( 'feed_content', $edited_Blog->get_setting( 'feed_content' ), array(
		array( 'none', T_('No feeds (disables sitemaps)') ),
		array( 'title', T_('Titles only') ),
		array( 'excerpt', T_('Post excerpts') ),
		array( 'normal', T_('Standard post contents (stopping at "&lt;!-- more -->")') ),
		array( 'full', T_('Full post contents (including after "&lt;!-- more -->")') ),
	), T_('Feed contents'), true, T_('How much content do you want to make available in feeds?') );
	$Form->text( 'posts_per_feed', $edited_Blog->get_setting( 'posts_per_feed' ), 4, T_('Posts in feeds'), T_('How many of the latest posts do you want to include in RSS & Atom feeds?'), 4 );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Multiple authors') );
	$Form->checkbox( 'advanced_perms', $edited_Blog->get( 'advanced_perms' ), T_('Use advanced perms'), T_('This will turn on the advanced User and Group permissions tabs for this blog.') );
	$Form->checkbox( 'blog_use_workflow', $edited_Blog->get_setting( 'use_workflow' ), T_('Use workflow'), T_('This will notably turn on the Tracker tab in the Posts view.') );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Subscriptions') );
	$Form->checkbox( 'allow_subscriptions', $edited_Blog->get_setting( 'allow_subscriptions' ), T_('Email subscriptions'), T_('Allow users to subscribe and receive email notifications for each new post and/or comment.') );
	// TODO: checkbox 'Enable RSS/Atom feeds'
	// TODO2: which feeds (templates)?
$Form->end_fieldset();

$Form->begin_fieldset( T_('List of public blogs') );
	$Form->checkbox( 'blog_in_bloglist', $edited_Blog->get( 'in_bloglist' ), T_('Include in public blog list'), T_('Check this if you want this blog to be advertised in the list of all public blogs on this system.') );
$Form->end_fieldset();

$Form->begin_fieldset( T_('After each new post...') );
	$ping_plugins = preg_split( '~\s*,\s*~', $edited_Blog->get_setting( 'ping_plugins' ), -1, PREG_SPLIT_NO_EMPTY);
	$available_ping_plugins = $Plugins->get_list_by_event('ItemSendPing');
	$displayed_ping_plugin = false;
	if( $available_ping_plugins )
	{
		foreach( $available_ping_plugins as $loop_Plugin )
		{
			if( empty($loop_Plugin->code) )
			{ // Ping plugin needs a code
				continue;
			}
			$displayed_ping_plugin = true;
			$checked = in_array( $loop_Plugin->code, $ping_plugins );
			$Form->checkbox_input( 'blog_ping_plugins[]', $checked, /* TRANS: %s is a ping service name */ sprintf( T_('Ping %s'), $loop_Plugin->ping_service_name ), array('value'=>$loop_Plugin->code, 'note'=>$loop_Plugin->ping_service_note) );
			while( ($key = array_search($loop_Plugin->code, $ping_plugins)) !== false )
			{
				unset($ping_plugins[$key]);
			}
		}
	}
	if( ! $displayed_ping_plugin )
	{
		echo '<p>'.T_('There are no ping plugins activated.').'</p>';
	}
	// Provide previous ping services as hidden fields, in case the plugin is temporarily disabled:
	foreach( $ping_plugins as $ping_plugin_code )
	{
		$Form->hidden( 'blog_ping_plugins[]', $ping_plugin_code );
	}
$Form->end_fieldset();

$Form->begin_fieldset( get_manual_link('blog-external-feeds').T_('External Feeds') );
	$Form->text_input( 'atom_redirect', $edited_Blog->get_setting( 'atom_redirect' ), 50, T_('Atom Feed URL'),
		'<br />'.T_('Example: Your Feedburner Atom URL which should replace the original feed URL.').'<br />'
			.sprintf( T_( 'Note: the original URL was: %s' ), url_add_param( $edited_Blog->get_item_feed_url( '_atom' ), 'redir=no' ) ),
		array('maxlength'=>255, 'class'=>'large') );
	$Form->text_input( 'rss2_redirect', $edited_Blog->get_setting( 'rss2_redirect' ), 50, T_('RSS2 Feed URL'),
		'<br />'.T_('Example: Your Feedburner RSS2 URL which should replace the original feed URL.').'<br />'
			.sprintf( T_( 'Note: the original URL was: %s' ), url_add_param( $edited_Blog->get_item_feed_url( '_rss2' ), 'redir=no' ) ),
		array('maxlength'=>255, 'class'=>'large') );
$Form->end_fieldset();

if( $current_User->check_perm( 'blog_admin', 'edit', false, $edited_Blog->ID ) )
{ // Permission to edit advanced admin settings
	$Form->begin_fieldset( T_('Caching').' ['.T_('Admin').']' );
		$Form->checkbox_input( 'cache_enabled', $edited_Blog->get_setting( 'cache_enabled' ), T_('Enable cache'), array( 'note'=>T_('Cache rendered blog pages') ) );
	$Form->end_fieldset();

	$Form->begin_fieldset( T_('Template and style').' ['.T_('Admin').']' );
		$TemplateCache = & get_Cache( 'TemplateCache' );
		$TemplateCache->load_all();
		$Form->select_input_object( 'blog_template_ID', $edited_Blog->template_ID, $TemplateCache, T_('Template') );
		$Form->checkbox( 'blog_allowblogcss', $edited_Blog->get( 'allowblogcss' ), T_('Allow customized blog CSS file'), T_('You will be able to customize the blog\'s template stylesheet with a file named style.css in the blog\'s media file folder.') );
		$Form->checkbox( 'blog_allowusercss', $edited_Blog->get( 'allowusercss' ), T_('Allow user customized CSS file for this blog'), T_('Users will be able to customize the blog and template stylesheets with a file named style.css in their personal file folder.') );
	$Form->end_fieldset();
}

$Form->end_form( array(
	array( 'submit', 'submit', T_('Save !'), 'SaveButton' ),
	array( 'reset', '', T_('Reset'), 'ResetButton' ) ) );

?>
