<?php
/**
 * This file implements the comment list
 *
 * This file is part of the Quam Plures project - {@link http://quamplures.net/}.
 * See also {@link https://launchpad.net/quam-plures}.
 *
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}.
 * Parts of this file are copyright (c)2005 by Daniel HAHLER - {@link http://thequod.de/contact}.
 *
 * @license http://quamplures.net/license.html GNU General Public License (GPL)
 *
 * {@internal Below is a list of authors who have contributed to design/coding of this file: }}
 * @author fplanque: Francois PLANQUE.
 *
 * @package pond
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * @var Comment
 */
global $Comment;
/**
 * @var Blog
 */
global $Blog;
/**
 * @var CommentList
 */
global $CommentList;

global $dispatcher;

while( $Comment = & $CommentList->get_next() )
{ // Loop through comments:
	?>
	<div id="c<?php echo $Comment->ID ?>" class="bComment bComment<?php $Comment->status('raw') ?>">
		<div class="bSmallHead">
			<div class="bSmallHeadRight">
			<?php echo T_('Visibility').': '; ?>
			<span class="bStatus">
			<?php $Comment->status(); ?>
			</span>
			</div>
			<?php
			// display the comment's date
			$Comment->date( array(
				'before' => '<span class="bDate">',
				'after' => '</span> @ ',
			) );

			// display the comment's time
			$Comment->time( array(
				'before' => '<span class="bTime">',
				'after' => '</span>',
				'format' => 'H:i',
			) );

			// display a link to comment author's URL
			if( $Comment->author_url( array(
				'before' => ' &middot; Url: <span class="bUrl">',
				'after' => '</span>',
			) )
					&& $current_User->check_perm( 'spamblacklist', 'edit' ) )
			{ // There is an URL and we have permission to ban...
				// TODO: really ban the base domain! - not by keyword
				echo ' <a href="'.$dispatcher.'?ctrl=antispam&amp;action=ban&amp;keyword='.rawurlencode(get_ban_domain($Comment->author_url))
					.'&amp;aspm_source=reported">'.get_icon( 'ban' ).'</a> ';
			}
			// display mailto link to comment author's email
			$Comment->author_email( array(
				'before' => ' &middot; Email: <span class="bEmail">',
				'after' => '</span>',
			) );
			// display comment author's IP address
			$Comment->author_ip( array(
				'before' => ' &middot; IP: <span class="bIP">',
				'after' => '</span>',
			) );
			echo ' &middot; <span class="bKarma">';
			$Comment->spam_karma( T_('Spam Karma').': %s%', T_('No Spam Karma') );
			echo '</span>';
		 ?>
		</div>
		<div class="bCommentContent">
		<div class="bTitle">
			<?php
			$comment_Item = & $Comment->get_Item();
			echo T_('In response to')
				.': <a href="?ctrl=items&amp;blog='.$Blog->ID.'&amp;p='.$comment_Item->ID.'">'.$comment_Item->dget('title').'</a>';
			?>
		</div>
		<div class="bCommentTitle">
			<?php echo $Comment->get_title(); ?>
		</div>
		<div class="bCommentText">
			<?php
			// display a comment's rating
			$Comment->rating( array() );
			$Comment->content(); // display the comment's contents
			?>
		</div>
		</div>
		<div class="CommentActionsArea">
			<?php
			// display a permalink link to the comment
			$Comment->permanent_link( array(
				'class' => 'permalink_right',
			) );
			// display a link to edit a comment
			$Comment->edit_link( array(
				'class' => 'ActionButton',
			) );
			// display a link to publish a comment
			$Comment->publish_link( array(
				'class' => 'PublishButton',
			) );
			// display a link to deprecate a comment
			$Comment->deprecate_link( array(
				'class' => 'DeleteButton',
			) );
			// display a link to delete a comment
			$Comment->delete_link( array(
				'class' => 'DeleteButton',
			) );
			?>
			<div class="clear"></div>
		</div>

	</div>
	<?php //end of the loop, don't delete
}

?>