<?php
/**
 * This file implements the UI view for the Advanced blog properties.
 *
 * This file is part of the Quam Plures project - {@link http://quamplures.net/}.
 * See also {@link https://launchpad.net/quam-plures}.
 *
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}.
 *
 * @license http://quamplures.net/license.html GNU General Public License (GPL)
 *
 * @package templates
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * @var Blog
 */
global $edited_Blog;

global $admin_url, $dispatcher;

$block_item_Widget = new Widget( 'block_item' );

$block_item_Widget->title = T_('Choose a template');

if( $current_User->check_perm( 'options', 'edit', false ) )
{ // We have permission to modify:
  $block_item_Widget->global_icon( T_('Manage installed templates...'), 'properties', $dispatcher.'?ctrl=templates', T_('Manage templates'), 3, 4 );
  $block_item_Widget->global_icon( T_('Install new template...'), 'new', $dispatcher.'?ctrl=templates&amp;action=new&amp;redirect_to='.rawurlencode(url_rel_to_same_host(regenerate_url('','','','&'), $admin_url)), T_('Install new'), 3, 4 );
}

$block_item_Widget->disp_template_replaced( 'block_start' );

	$TemplateCache = & get_Cache( 'TemplateCache' );
	$TemplateCache->load_all();

	// TODO: this is like touching private parts :>
	foreach( $TemplateCache->cache as $Template )
	{
		if( $Template->type != 'normal' )
		{	// This template cannot be used here...
			continue;
		}

		$selected = ($edited_Blog->template_ID == $Template->ID);
		$select_url = '?ctrl=coll_settings&tab=template&blog='.$edited_Blog->ID.'&amp;action=update&amp;blog_template_ID='.$Template->ID;
		$preview_url = url_add_param( $edited_Blog->gen_blogurl(), 'viewmode='.rawurlencode($Template->folder) );

		// Display screenshot:
		Template::disp_screenshot( $Template->folder, $Template->name, 'select', $selected, $select_url, $preview_url );
	}

	echo '<div class="clear"></div>';

$block_item_Widget->disp_template_replaced( 'block_end' );

?>