<?php
/**
 * This file implements the Template properties form.
 *
 * This file is part of Quam Plures - {@link http://quamplures.net/}
 * See also {@link https://launchpad.net/quam-plures}.
 *
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 *
 * {@internal License choice
 * - If you have received this file as part of a package, please find the license.txt file in
 *   the same folder or the closest folder above for complete license terms.
 * - If you have received this file individually (e-g: from http://evocms.cvs.sourceforge.net/)
 *   then you must choose one of the following licenses before using the file:
 *   - GNU General Public License 2 (GPL) - http://www.opensource.org/licenses/gpl-license.php
 *   - Mozilla Public License 1.1 (MPL) - http://www.opensource.org/licenses/mozilla1.1.php
 * }}
 *
 * {@internal Open Source relicensing agreement:
 * }}
 *
 * @author fplanque: Francois PLANQUE.
 *
 * @package templates
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * @var Template
 */
global $edited_Template;

/**
 * @var Blog
 */
global $Blog;

$Form = new Form( NULL, 'template_settings_checkchanges' );

$Form->begin_form( 'fform' );

$Form->hidden_ctrl();
$Form->hidden( 'tab', 'template_settings' );
$Form->hidden( 'action', 'update' );
$Form->hidden( 'blog', $Blog->ID );

$Form->begin_fieldset( T_('Current template') );
	Template::disp_screenshot( $edited_Template->folder, $edited_Template->name );
	$Form->info( T_('Template name'), $edited_Template->name );
	$Form->info( T_('Template type'), $edited_Template->type );
	if( $template_containers = $edited_Template->get_containers() )
	{
		$container_ul = implode( ', ', $template_containers );
	}
	else
	{
		$container_ul = '-';
	}
	$Form->info( T_('Containers'), $container_ul );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Params') );
	$template_params = $edited_Template->get_param_definitions( $tmp_params = array('for_editing'=>true) );
	if( empty($template_params) )
	{ // Advertise this feature!!
		echo '<p>'.T_('This template does not provide any configurable settings.').'</p>';
	}
	else
	{
		load_funcs( 'plugins/_plugin.funcs.php' );
		foreach( $template_params as $l_name => $l_meta )
		{ // Loop through all widget params:
			autoform_display_field( $l_name, $l_meta, $Form, 'Template', $edited_Template );
		}
	}
$Form->end_fieldset();

if( empty($template_params) )
{ // end without buttons
	$Form->end_form();
}
else
{
	$Form->end_form( array(
			array( 'submit', 'submit', T_('Update'), 'SaveButton' ),
			array( 'reset', '', T_('Reset'), 'ResetButton' )
		) );
}

?>
