<?php
/**
 * This file implements the Template properties form.
 *
 * This file is part of Quam Plures - {@link http://quamplures.net/}
 * See also {@link https://launchpad.net/quam-plures}.
 *
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 *
 * {@internal License choice
 * - If you have received this file as part of a package, please find the license.txt file in
 *   the same folder or the closest folder above for complete license terms.
 * - If you have received this file individually (e-g: from http://evocms.cvs.sourceforge.net/)
 *   then you must choose one of the following licenses before using the file:
 *   - GNU General Public License 2 (GPL) - http://www.opensource.org/licenses/gpl-license.php
 *   - Mozilla Public License 1.1 (MPL) - http://www.opensource.org/licenses/mozilla1.1.php
 * }}
 *
 * {@internal Open Source relicensing agreement:
 * }}
 *
 * @author fplanque: Francois PLANQUE.
 *
 * @package templates
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * @var Template
 */
global $edited_Template;


$Form = new Form( NULL, 'template_checkchanges' );

$Form->global_icon( T_('Uninstall this template!'), 'delete', regenerate_url( 'action', 'action=delete' ) );
$Form->global_icon( T_('Cancel editing!'), 'close', regenerate_url( 'action' ) );

$Form->begin_form( 'fform', T_('Template properties') );

	$Form->hidden_ctrl();
	$Form->hidden( 'action', 'update' );
	$Form->hidden( 'template_ID', $edited_Template->ID );

	$Form->begin_fieldset( T_('Template properties') );

		Template::disp_screenshot( $edited_Template->folder, $edited_Template->name );

		$Form->text_input( 'template_name', $edited_Template->name, 32, T_('Template name'), T_('As seen by blog owners'), array( 'required'=>true ) );

		$Form->radio( 'template_type',
									$edited_Template->type,
									 array(
													array( 'normal', T_( 'Normal' ), T_( 'Normal template for general browsing' ) ),
													array( 'feed', T_( 'XML Feed' ), T_( 'Special system template for XML feeds like RSS and Atom' ) ),
												),
										T_( 'Template type' ),
										true // separate lines
								 );

		if( $template_containers = $edited_Template->get_containers() )
		{
			$container_ul = '<ul><li>'.implode( '</li><li>', $template_containers ).'</li></ul>';
		}
		else
		{
			$container_ul = '-';
		}
		$Form->info( T_('Containers'), $container_ul );

	$Form->end_fieldset();

$Form->end_form( array( array( 'submit', 'submit', T_('Update'), 'SaveButton' ),
													array( 'reset', '', T_('Reset'), 'ResetButton' ) ) );


?>