<?php
/**
 * This file implements the UI view for the Available templates.
 *
 * This file is part of the Quam Plures project - {@link http://quamplures.net/}.
 * See also {@link https://launchpad.net/quam-plures}.
 *
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}.
 *
 * @license http://quamplures.net/license.html GNU General Public License (GPL)
 *
 * @package templates
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

global $templates_path;

global $redirect_to;

/**
 * @var TemplateCache
 */
$TemplateCache = & get_Cache( 'TemplateCache' );
$TemplateCache->load_all();

$block_item_Widget = new Widget( 'block_item' );

$block_item_Widget->title = T_('Templates available for installation');

if( $current_User->check_perm( 'options', 'edit', false ) )
{ // We have permission to modify:
  $block_item_Widget->global_icon( T_('Cancel install!'), 'close', $redirect_to );
}

$block_item_Widget->disp_template_replaced( 'block_start' );

// Get all template folder names:
$template_folders = get_filenames( $templates_path, false, true, true, false, true );
// Go through all template folders:
foreach( $template_folders as $template_folder )
{
	if( ! strlen($template_folder) || $template_folder[0] == '.' || $template_folder == 'CVS' )
	{
		continue;
	}
	if( $TemplateCache->get_by_folder( $template_folder, false ) )
	{	// Already installed...
		continue;
	}

	// Display screenshot:
	$function_url = '?ctrl=templates&amp;action=create&amp;template_folder='.rawurlencode($template_folder).'&amp;redirect_to='.rawurlencode($redirect_to);
	Template::disp_screenshot( $template_folder, $template_folder, 'install', false, NULL, $function_url );
}

echo '<div class="clear"></div>';
$block_item_Widget->disp_template_replaced( 'block_end' );

?>