<?php
/**
 * This file implements the UI controller for System configuration and analysis.
 *
 * @package pond
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

?>
<style type="text/css">
td, th, h1, h2 {font-family: sans-serif;}
.panelblock a:link {color: #000099; text-decoration: none; background-color: #ffffff;}
.panelblock a:hover {text-decoration: underline;}
table {border-collapse: collapse;}
div.center { overflow: auto; }
.center table { margin-left: auto; margin-right: auto; text-align: left; }
.center th { text-align: center !important; }
td, th { border: 1px solid #000000; vertical-align: baseline;}
h1 {font-size: 150%;}
h2 {font-size: 125%;}
.center h1, .center h2 {text-align: left;background-color: #9999cc;margin:1ex 0 0 0;padding:2px 2ex}
.grouped tr.h {background-color: #9999cc; font-weight: bold; color: #000000;}
.v {background-color: #cccccc; color: #000000;}
.vr {background-color: #cccccc; text-align: right; color: #000000;}
</style>

<?php
$Form = new Form( NULL, 'phpinfo' );
$Form->global_icon( T_('Cancel!'), 'close', regenerate_url( 'action' ) );
$Form->begin_form( 'fform', T_('Your server\'s phpinfo() response') );

$subact = param( 'subact', 'integer', INFO_ALL );

// lifted with reckless abandon from http://www.php.net/manual/en/function.phpinfo.php#87287
// then frankensteined into the awesome display of awesomeness you see here now, by me (EdB) :)
ob_start();
phpinfo( $subact );
$pinfo = ob_get_contents();
ob_end_clean();
// the name attribute "module_Zend Optimizer" of an anker-tag is not xhtml valide, so replace it with "module_Zend_Optimizer"
$pinfo = preg_replace( '%^.*<body>(.*)</body>.*$%ms', '$1', $pinfo );
$pinfo = str_replace( 'module_Zend Optimizer', 'module_Zend_Optimizer', $pinfo );
$pinfo = str_replace( '<table border="0" cellpadding="3" width="600">', '<table class="grouped" cellspacing="0">', $pinfo );
$pinfo = str_replace( '<tr><td class="e">', '<tr class="even"><td class="firstcol">', $pinfo );
$pinfo = str_replace( '<td class="v">', '<td class="lastcol">', $pinfo );
$pinfo = str_replace( '<img border="0"', '<img class="floatright"', $pinfo );
$pinfo = str_replace( '<hr />', '', $pinfo );
$pinfo = str_replace( '</table><br />', '</table>', $pinfo );

echo $pinfo;

$Form->end_form();

?>
