<?php
/**
 * This file implements creation of DB tables
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 * Parts of this file are copyright (c)2004 by Vegar BERG GULDAL - {@link http://funky-m.com/}
 * Parts of this file are copyright (c)2005 by Jason EDGECOMBE
 *
 * @license http://quamplures.net/license.html GNU General Public License (GPL)
 *
 * {@internal Open Source relicensing agreement:
 * Daniel HAHLER grants Francois PLANQUE the right to license
 * Daniel HAHLER's contributions to this file and the b2evolution project
 * under any OSI approved OSS license (http://www.opensource.org/licenses/).
 *
 * Vegar BERG GULDAL grants Francois PLANQUE the right to license
 * Vegar BERG GULDAL's contributions to this file and the b2evolution project
 * under any OSI approved OSS license (http://www.opensource.org/licenses/).
 *
 * Jason EDGECOMBE grants Francois PLANQUE the right to license
 * Jason EDGECOMBE's contributions to this file and the b2evolution project
 * under any OSI approved OSS license (http://www.opensource.org/licenses/).
 *
 * Matt FOLLETT grants Francois PLANQUE the right to license
 * Matt FOLLETT contributions to this file and the b2evolution project
 * under any OSI approved OSS license (http://www.opensource.org/licenses/).
 * }}
 *
 * {@internal Below is a list of authors who have contributed to design/coding of this file: }}
 * @author blueyed: Daniel HAHLER.
 * @author fplanque: Francois PLANQUE.
 * @author vegarg: Vegar BERG GULDAL.
 * @author edgester: Jason EDGECOMBE.
 * @author mfollett: Matt Follett.
 *
 * @package pond
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

load_class( 'users/model/_group.class.php' );
load_funcs( 'collections/model/_category.funcs.php' );

/**
 * Used for fresh install
 */
function create_tables()
{
	global $inc_path;

	// Load DB schema from modules
	load_db_schema();

	load_funcs('_core/model/db/_upgrade.funcs.php');

	// Alter DB to match DB schema:
	install_make_db_schema_current( true );
}


/**
 * Insert all default data:
 */
function create_default_data()
{
	global $Group_Admins, $Group_Special, $Group_Bloggers, $Group_Users;
	global $DB, $locales, $current_locale;

	// Inserting sample data triggers events: instead of checking if $Plugins is an object there, just use a fake one..
	load_class('plugins/model/_plugins_admin_no_db.class.php');
	global $Plugins;
	$Plugins = new Plugins_admin_no_DB(); // COPY

	echo 'Creating default blacklist entries... ';
	$query = "INSERT INTO T_antispam(aspm_string) VALUES ".
	"('online-casino'), ('penis-enlargement'), ".
	"('order-viagra'), ('order-phentermine'), ('order-xenical'), ".
	"('order-prophecia'), ('sexy-lingerie'), ('-porn-'), ".
	"('-adult-'), ('-tits-'), ('buy-phentermine'), ".
	"('order-cheap-pills'), ('buy-xenadrine'),	('xxx'), ".
	"('paris-hilton'), ('parishilton'), ('camgirls'), ('adult-models')";
	$DB->query( $query );
	echo "OK.<br />\n";


	// highest order of permissions for group #1
	echo 'Creating default groups... ';
	$Group_Admins = new Group(); // COPY !
	$Group_Admins->set( 'name', 'Administrators' );
	$Group_Admins->set( 'perm_admin', 'visible' );
	$Group_Admins->set( 'perm_blogs', 'editall' );
	$Group_Admins->set( 'perm_xhtml_css_tweaks', 1 );
	$Group_Admins->set( 'perm_stats', 'edit' );
	$Group_Admins->set( 'perm_spamblacklist', 'edit' );
	$Group_Admins->set( 'perm_options', 'edit' );
	$Group_Admins->set( 'perm_users', 'edit' );
	$Group_Admins->set( 'perm_templates', 1 );
	$Group_Admins->set( 'perm_files', 'all' );
	$Group_Admins->dbinsert();


	// permissions generally one step down from group #1
	$Group_Special = new Group();
	$Group_Special->set( 'name', 'Special Bloggers' );
	$Group_Special->set( 'perm_admin', 'visible' );
	$Group_Special->set( 'perm_blogs', 'viewall' );
	$Group_Special->set( 'perm_xhtml_css_tweaks', 1 );
	$Group_Special->set( 'perm_stats', 'view' );
	$Group_Special->set( 'perm_spamblacklist', 'view' );
	$Group_Special->set( 'perm_options', 'view' );
	$Group_Special->set( 'perm_users', 'view' );
	$Group_Special->set( 'perm_templates', 0 );
	$Group_Special->set( 'perm_files', 'edit' );
	$Group_Special->dbinsert();


	// permissions generally one step down from group #2
	$Group_Bloggers = new Group();
	$Group_Bloggers->set( 'name', 'Bloggers' );
	$Group_Bloggers->set( 'perm_admin', 'hidden' );
	$Group_Bloggers->set( 'perm_blogs', 'user' );
	$Group_Bloggers->set( 'perm_stats', 'user' );
	$Group_Bloggers->set( 'perm_spamblacklist', 'none' );
	$Group_Bloggers->set( 'perm_options', 'none' );
	$Group_Bloggers->set( 'perm_users', 'none' );
	$Group_Bloggers->set( 'perm_templates', 0 );
	$Group_Bloggers->set( 'perm_files', 'add' );
	$Group_Bloggers->dbinsert();


	// permissions generally one step down from group #3
	$Group_Users = new Group();
	$Group_Users->set( 'name', 'Basic Users' );
	$Group_Users->set( 'perm_admin', 'hidden' );
	$Group_Users->set( 'perm_blogs', 'user' );
	$Group_Users->set( 'perm_stats', 'none' );
	$Group_Users->set( 'perm_spamblacklist', 'none' );
	$Group_Users->set( 'perm_options', 'none' );
	$Group_Users->set( 'perm_users', 'none' );
	$Group_Users->set( 'perm_templates', 0 );
	$Group_Users->set( 'perm_files', 'view' );
	$Group_Users->dbinsert();
	echo "OK.<br />\n";

	echo 'Creating user field definitions... ';
	$DB->query( "
		INSERT INTO T_plugin_sharedfields (psf_fieldname, psf_label, psf_type, psf_note, psf_validate)
		 VALUES ( 'address_1', 'Address 1', 'text', 'note', 'none' ),
						( 'address_2', 'Address 2', 'text', 'note', 'none' ),
						( 'city', 'City', 'text', 'note', 'none' ),
						( 'county', 'County', 'text', 'note', 'none' ),
						( 'state', 'State', 'text', 'note', 'none' ),
						( 'province', 'Province', 'text', 'note', 'none' ),
						( 'postal_code', 'Postal Code', 'text', 'note', 'none' ),
						( 'nation', 'Nation', 'text', 'note', 'none' ),
						( 'home_phone', 'Home Phone', 'text', 'note', 'phone' ),
						( 'cell_phone', 'Cell Phone', 'text', 'note', 'phone' ),
						( 'home_fax', 'Home FAX', 'text', 'note', 'phone' ),
						( 'birthday', 'Birthday', 'text', 'note', 'none' ),
						( 'gender', 'Gender', 'text', 'note', 'none' ),
						( 'avatar_ID', 'Avatar File #', 'text', 'note', 'number' ),
						( 'digg_url', 'Digg', 'text', 'note', 'url' ),
						( 'facebook', 'Facebook', 'text', 'note', 'url' ),
						( 'flickr', 'Flickr', 'text', 'note', 'url' ),
						( 'linkdin', 'LinkedIn', 'text', 'note', 'url' ),
						( 'myspace', 'Myspace', 'text', 'note', 'url' ),
						( 'stumble', 'StumbleUpon', 'text', 'note', 'url' ),
						( 'twitter', 'Twitter', 'text', 'note', 'url' ),
						( 'youtube', 'YouTube', 'text', 'note', 'url' ),
						( 'aol_aim', 'AOL AIM', 'text', 'note', 'none' ),
						( 'icq_id', 'ICQ ID', 'text', 'note', 'none' ),
						( 'jabber', 'Jabber', 'text', 'note', 'none' ),
						( 'msn_im', 'MSN IM', 'text', 'note', 'none' ),
						( 'skype', 'Skype ID', 'text', 'note', 'none' ),
						( 'yahoo_im', 'Yahoo IM', 'text', 'note', 'none' );" );
	echo "OK.<br />\n";


	task_begin('Creating default users (one per group)...');
	global $timestamp, $default_locale;

	$User_Admin = new User();
	$User_Admin->set( 'login', param('conf_admin_login', 'string' ) );
	$User_Admin->set( 'pass', md5(param('conf_admin_pass', 'string' )) );
	$User_Admin->set( 'nickname', 'admin' );
	$User_Admin->set_email( param('conf_admin_email', 'string' ) );
	$User_Admin->set( 'validated', 1 ); // assume it's validated
	$User_Admin->set( 'ip', '127.0.0.1' );
	$User_Admin->set( 'domain', 'localhost' );
	$User_Admin->set( 'level', 10 );
	$User_Admin->set( 'locale', $default_locale );
	$User_Admin->set_datecreated( installer_timestamp() );
	$User_Admin->set_Group( $Group_Admins );
	$User_Admin->dbinsert();

	$User_Special = new User();
	$User_Special->set( 'login', 'demospecial' );
	$User_Special->set( 'pass', md5(param('conf_admin_pass', 'string' )) );
	$User_Special->set( 'nickname', 'demospecial' );
	$User_Special->set_email( param('conf_admin_email', 'string') );
	$User_Special->set( 'validated', 1 ); // assume it's validated
	$User_Special->set( 'ip', '127.0.0.1' );
	$User_Special->set( 'domain', 'localhost' );
	$User_Special->set( 'level', 1 );
	$User_Special->set( 'locale', $default_locale );
	$User_Special->set_datecreated( installer_timestamp() );
	$User_Special->set_Group( $Group_Special );
	$User_Special->dbinsert();

	$User_Bloggers = new User();
	$User_Bloggers->set( 'login', 'demoblogger' );
	$User_Bloggers->set( 'pass', md5(param('conf_admin_pass', 'string' )) );
	$User_Bloggers->set( 'nickname', 'demoblogger' );
	$User_Bloggers->set_email( param('conf_admin_email', 'string') );
	$User_Bloggers->set( 'validated', 1 );
	$User_Bloggers->set( 'ip', '127.0.0.1' );
	$User_Bloggers->set( 'domain', 'localhost' );
	$User_Bloggers->set( 'level', 1 );
	$User_Bloggers->set( 'locale', $default_locale );
	$User_Bloggers->set_datecreated( installer_timestamp() );
	$User_Bloggers->set_Group( $Group_Bloggers );
	$User_Bloggers->dbinsert();

	$User_Demo = new User();
	$User_Demo->set( 'login', 'demouser' );
	$User_Demo->set( 'pass', md5(param('conf_admin_pass', 'string' )) );
	$User_Demo->set( 'nickname', 'demouser' );
	$User_Demo->set_email( param('conf_admin_email', 'string') );
	$User_Demo->set( 'validated', 1 );
	$User_Demo->set( 'ip', '127.0.0.1' );
	$User_Demo->set( 'domain', 'localhost' );
	$User_Demo->set( 'level', 0 );
	$User_Demo->set( 'locale', $default_locale );
	$User_Demo->set_datecreated( installer_timestamp() );
	$User_Demo->set_Group( $Group_Users );
	$User_Demo->dbinsert();

	task_end();

	// added in Phoenix-Alpha
	echo 'Creating default Post Types... ';
	$DB->query( "
		INSERT INTO T_items__type ( ptyp_ID, ptyp_name )
		VALUES ( 1, 'Post' ),
					 ( 1000, 'Page' ),
					 ( 1500, 'Intro-Main' ),
					 ( 1520, 'Intro-Cat' ),
					 ( 1530, 'Intro-Tag' ),
					 ( 1570, 'Intro-Sub' ),
					 ( 1600, 'Intro-All' ),
					 ( 2000, 'Podcast' ),
					 ( 3000, 'Sidebar link' ),
					 ( 4000, 'Reserved' ),
					 ( 5000, 'Reserved' ) " );
	echo "OK.<br />\n";


	// added in Phoenix-Beta
	echo 'Creating default file types... ';
	// Contribs: feel free to add more types here...
	// TODO: dh> shouldn't they get localized to the app's default locale? fp> ftyp_name, yes
	$DB->query( "INSERT INTO T_filetypes
			(ftyp_ID, ftyp_extensions, ftyp_name, ftyp_mimetype, ftyp_icon, ftyp_viewtype, ftyp_allowed)
		VALUES
			(1, 'gif', 'GIF image', 'image/gif', 'gif.png', 'image', 1),
			(2, 'png', 'PNG image', 'image/png', 'png.gif', 'image', 1),
			(3, 'jpg jpeg', 'JPEG image', 'image/jpeg', 'jpg.gif', 'image', 1),
			(4, 'txt', 'Text file', 'text/plain', 'text.png', 'text', 1),
			(5, 'htm html', 'HTML file', 'text/html', 'html.png', 'browser', 0),
			(6, 'pdf', 'PDF file', 'application/pdf', 'pdf.png', 'browser', 1),
			(7, 'doc', 'Microsoft Word file', 'application/msword', 'doc.gif', 'external', 1),
			(8, 'xls', 'Microsoft Excel file', 'application/vnd.ms-excel', 'xls.gif', 'external', 1),
			(9, 'ppt', 'Powerpoint', 'application/vnd.ms-powerpoint', 'ppt.gif', 'external', 1),
			(10, 'pps', 'Slideshow', 'pps', 'pps.gif', 'external', 1),
			(11, 'zip', 'ZIP archive', 'application/zip', 'zip.gif', 'external', 1),
			(12, 'php php3 php4 php5 php6', 'PHP script', 'application/x-httpd-php', 'php.png', 'text', 0),
			(13, 'css', 'Style sheet', 'text/css', 'css.png', 'text', 1),
			(14, 'mp3', 'MPEG audio file', 'audio/mpeg', 'mp3.png', 'browser', 1),
			(15, 'm4a', 'MPEG audio file', 'audio/x-m4a', 'm4a.png', 'browser', 1),
			(16, 'mp4', 'MPEG video', 'video/mp4', 'mp4.png', 'browser', 1),
			(17, 'mov', 'Quicktime video', 'video/quicktime', 'mov.png', 'browser', 1)
		" );
	echo "OK.<br />\n";

	if( ! empty( $current_locale ) )
	{	// Make sure the user sees his new system localized.
		echo 'Activating selected default locale... ';
		$DB->query( 'INSERT INTO T_locales '
				.'( loc_locale, loc_charset, loc_datefmt, loc_timefmt, '
				.'loc_startofweek, loc_name, loc_messages, loc_priority, '
				.'loc_enabled ) '
				.'VALUES ( '.$DB->quote( $current_locale ).', '
				.$DB->quote( $locales[$current_locale]['charset'] ).', '
				.$DB->quote( $locales[$current_locale]['datefmt'] ).', '
				.$DB->quote( $locales[$current_locale]['timefmt'] ).', '
				.$DB->quote( $locales[$current_locale]['startofweek'] ).', '
				.$DB->quote( $locales[$current_locale]['name'] ).', '
				.$DB->quote( $locales[$current_locale]['messages'] ).', '
				.$DB->quote( $locales[$current_locale]['priority'] ).', '
				.' 1)' );
		echo 'OK.<br />', "\n";
	}

	create_default_settings();

	install_basic_templates();

	install_basic_plugins();

	return true;
}


/**
 * Create a new a blog
 * This funtion has to handle all needed DB dependencies!
 *
 * @todo move this to Blog object (only half done here)
 */
function create_blog(
	$blog_name,
	$blog_shortname,
	$blog_urlname,
	$blog_tagline = '',
	$blog_longdesc = '',
	$blog_template_ID = 1,
	$kind = 'std', // standard blog; notorious variation: "photo"
	$num_posts = 5 )
{
	global $default_locale;

 	$Blog = new Blog( NULL );

	$Blog->init_by_kind( $kind, $blog_name, $blog_shortname, $blog_urlname );

	$Blog->set( 'tagline', $blog_tagline );
	$Blog->set( 'longdesc', $blog_longdesc );
	$Blog->set( 'locale', $default_locale );
	$Blog->set( 'template_ID', $blog_template_ID );
	$Blog->set_setting( 'posts_per_page', $num_posts );
	$Blog->dbinsert();

	if( $Blog->ID === 1 )
	{
		$Blog->set( 'access_type', 'default' );
	}
	else
	{
		$Blog->set( 'access_type', 'relative' );
		$Blog->set( 'siteurl', 'blog'.$Blog->ID.'.php' );
	}

	$Blog->dbupdate();

	return $Blog->ID;
}


/**
 * Spread the sample entries across the past ... do the "worst case" math!
 *
 * $timestamp uses the total count ($count_samples + $count_contribs) as the
 * number of days in the past to use as the starting point for the installation.
 *
 * $count_samples includes 2 instances of "installer_timestamp()" that are not
 * actual sample posts.  The actual function name and once that gets reused
 * foreach( contributor ).  "minus 2" will help us :)
 *
 * $count_contribs counts the number of elements in the contributors array.
 *
 * $backdate is how far back we pushed the starting point, or the second half of
 * $timestamp = ( time() - ( ( count_samples + count_contribs ) * 86400 ) );
 *
 * $max_per_item_spread is the maximum real delta between time stamps, accounting
 * for the 2 instances of installer_timestamp() that are not applications of a time
 * stamp. This will, by design, be greater than the number of seconds in one day.
 *
 * $ave_per_item_spread is simply the max minus 2 hours in seconds, which would
 * be the average between it + or - 7200 :)
 *
 * $fixed_entry_delta is the float rounded down to the next whole int value.  We
 * need that to make sure that the most recent item is always in the past.
 *
 * This function modifies timestamp by a fixed amount of time +/- 2 hours, so
 * the "worst case" math has to have the latest entry in the past. If the "coin
 * toss" always comes up heads and the random addition is always 7200 we can now
 * calculate backwards to find what the minimum fixed amount of time needs to be.
 *
 * NOTE: using $timestamp inside if( $fixed_entry_delta === NULL ) ensures we
 * never get closer than a day to right now.
 *
 * @todo EdB: do this the other way. Create an array for timestamps with values
 * for each timestamped bit based on the most recent is "now minus 10 seconds"
 * and 24 +/-4 hours between items, then flip the array and work through it as
 * we insert posts.  That gives us built-in variance between posts and the most
 * recent will always be right about now :)
 *
 * @return integer The new $timestamp value.
 */
function installer_timestamp()
{
	// Read:
	global $count_samples, $count_contribs;
	// Write:
	global $timestamp;

	static $fixed_entry_delta = NULL;

	if( $fixed_entry_delta === NULL )
	{
		$backdate = ( ( $count_samples + $count_contribs ) * 86400 );
		$max_per_item_spread = ( $backdate / ( $count_samples + $count_contribs - 2 ) );
		$ave_per_item_spread = ( $max_per_item_spread - 7200 );
		$fixed_entry_delta = floor( $ave_per_item_spread );

		// don't believe in badass math? uncomment the next 2 lines and do an install - you'll see!
		//$foo = array( 'count_samples' => $count_samples, 'count_contribs' => $count_contribs, 'backdate' => $backdate, 'max_per_item_spread' => $max_per_item_spread, 'ave_per_item_spread' => $ave_per_item_spread, 'fixed_entry_delta' => $fixed_entry_delta );
		//pre_dump( $foo );
		return $timestamp;
	}

	if( mt_rand(2,3) === 2 )
	{ // coin toss is heads, add time+
		$timestamp += $fixed_entry_delta + mt_rand(0,7200); 
	}
	else
	{ // coin toss is tails, add time-
		$timestamp += $fixed_entry_delta - mt_rand(0,7200);
	}

	return $timestamp;
}


/**
 * This is called only for fresh installs and fills the tables with
 * demo/tutorial things.
 */
function create_demo_contents()
{
	global $app_baseurl, $app_db_version;
	global $query;
	global $timestamp;
	global $Group_Admins, $Group_Special, $Group_Bloggers, $Group_Users;
	global $blog_all_ID, $blog_a_ID, $blog_b_ID, $blog_linkblog_ID;
	global $DB;
	global $default_locale;
	global $Plugins, $app_name, $app_version;
	global $FileRootCache;
	global $templates_path;

	load_class( 'collections/model/_blog.class.php' );
	load_class( 'files/model/_file.class.php' );
	load_class( 'files/model/_filetype.class.php' );
	load_class( 'items/model/_link.class.php' );

	global $default_locale, $query, $timestamp;
	global $blog_all_ID, $blog_a_ID, $blog_b_ID, $blog_linkblog_ID;

	$default_blog_longdesc = T_("This is the long description for the blog named '%s'. %s");

	echo "Creating default blogs... ";

	$blog_shortname = 'Blog A';
	$blog_a_long = sprintf( T_('%s Title'), $blog_shortname );
	$blog_stub = 'a';
	$blog_a_ID = create_blog(
		$blog_a_long,
		$blog_shortname,
		$blog_stub,
		sprintf( T_('Tagline for %s'), $blog_shortname ),
		sprintf( $default_blog_longdesc, $blog_shortname, '' ),
		1, 'std' ); // Template ID, type

	$blog_shortname = 'Blog B';
	$blog_stub = 'b';
	$blog_b_ID = create_blog(
		sprintf( T_('%s Title'), $blog_shortname ),
		$blog_shortname,
		$blog_stub,
		sprintf( T_('Tagline for %s'), $blog_shortname ),
		sprintf( $default_blog_longdesc, $blog_shortname, '' ),
		2, 'std' ); // Template ID, type

	$blog_shortname = 'Linkblog';
	$blog_stub = 'links';
	$blog_more_longdesc = '<br />
<br />
<strong>'.T_('The main purpose for this blog is to be included as a side item to other blogs where it will display your favorite/related links.').'</strong>';
	$blog_linkblog_ID = create_blog(
		'Linkblog',
		$blog_shortname,
		$blog_stub,
		T_('Some interesting links...'),
		sprintf( $default_blog_longdesc, $blog_shortname, $blog_more_longdesc ),
		3, 'std', 100 ); // template ID, type, num_posts

	$blog_shortname = 'Photoblog';
	$blog_stub = 'photos';
	$blog_more_longdesc = '<br />
<br />
<strong>'.T_('This is a photoblog, optimized for displaying photos.').'</strong>';
	$blog_photoblog_ID = create_blog(
		'Photoblog',
		$blog_shortname,
		$blog_stub,
		T_('This blog shows photos...'),
		sprintf( $default_blog_longdesc, $blog_shortname, $blog_more_longdesc ),
		4, 'photo', 1 ); // template ID, type, num_posts

	echo "OK.<br />\n";


	global $query, $timestamp;

	echo 'Creating sample categories... ';

	// Create categories for blog A
	$cat_welcome = cat_create( 'Welcome', 'NULL', $blog_a_ID );
	$cat_news = cat_create( 'News', 'NULL', $blog_a_ID );
	$cat_post_features = cat_create( 'Post features', 'NULL', $blog_a_ID );

	// Create categories for blog B
	$cat_ann_b = cat_create( 'Announcements', 'NULL', $blog_b_ID );
	$cat_appname = cat_create( sprintf( '%s Tips', $app_name ), 'NULL', $blog_b_ID );
	$cat_writepage = cat_create( 'Write page', 'NULL', $blog_b_ID );
		$cat_mainbody = cat_create( 'Main body', $cat_writepage, $blog_b_ID );
			$cat_contents = cat_create( 'Post contents', $cat_mainbody, $blog_b_ID );
			$cat_images = cat_create( 'Images & Attachments', $cat_mainbody, $blog_b_ID );
			$cat_advanced = cat_create( 'Advanced properties', $cat_mainbody, $blog_b_ID );
		$cat_sidebar = cat_create( 'Sidebar', $cat_writepage, $blog_b_ID );
			$cat_categories = cat_create( 'Categories', $cat_sidebar, $blog_b_ID );
			$cat_properties = cat_create( 'Properties', $cat_sidebar, $blog_b_ID );
			$cat_visibility = cat_create( 'Visibility / Sharing', $cat_sidebar, $blog_b_ID );
			$cat_renderers = cat_create( 'Text Renderers', $cat_sidebar, $blog_b_ID );
			$cat_comments = cat_create( 'Comments', $cat_sidebar, $blog_b_ID );
		$cat_toolbars = cat_create( 'Toolbars', $cat_writepage, $blog_b_ID );

	// Create categories for linkblog
	$cat_linkblog_b2evo = cat_create( $app_name, 'NULL', $blog_linkblog_ID );
	$cat_linkblog_contrib = cat_create( 'Contributors', 'NULL', $blog_linkblog_ID );

	// Create categories for photoblog
	$cat_photo_album = cat_create( 'Monument Valley', 'NULL', $blog_photoblog_ID );

	echo "OK.<br />\n";


	echo 'Creating sample posts and comments... ';

	global $app_baseurl;

	// sets up inserting tags without knowing what tags are used by which post IDs
	$tag_id_counter = 0;

	// Insert a post into blog #1:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('First Post'), sprintf( T_('<p>This is the first post. It appears in a single category, and has 2 comments.</p>

<p>The first comment has been published (approved), and the second is in draft (moderation). Log in to see and approve or delete the second comment.</p>

<p>By the way both of these comments are impossible given the default configuration: anonymous comments are not enabled. They are here only to show you about comments in %s.</p>'), $app_name ),
		$now, $cat_welcome );


	// Insert a post into blog #1:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Second post'), sprintf( T_('<p>This is the second post. It appears in multiple categories.</p>

<p>Each post (or "item") must be in a primary category, and can also have additional "sub-categories". There is no limit to how many categories a post can be attached to. It is also possible to configure %s to allow posts to be attached to categories in different blogs.</p>

<p>Technically each post is attached to a category which is attached to a blog, instead of the post being directly tied to a blog. That may be a small internal detail, but it causes confusion so there you go!</p>'), $app_name ),
		$now, $cat_news, array( $cat_welcome ) );


	// Insert a post into blog #3:
	// reverse alpha order so date order is alpha order ;)
	require( $templates_path.'/_contributors.php' );
	krsort( $_hic_sunt_dracones );
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, sprintf( T_('%s Contributors'), $app_name ), '<p>'.sprintf( T_('%s would like to thank the following contributors for making version %s possible').'</p><p>hic sunt dracones! as EdB would say ;)</p>', $app_name, $app_version ),
		$now, $cat_linkblog_contrib, array(), 'published', '#', '', '', 'disabled', array('default'), 1520 );


	// Insert a post into blog #3 for each contributor:
	foreach( $_hic_sunt_dracones as $_dracone )
	{
		$now = date('Y-m-d H:i:s',installer_timestamp());
		$edited_Item = new Item();
		$edited_Item->insert( 1, $_dracone['name'], '<p>'.$_dracone['spiel'].'</p>',
		$now, $cat_linkblog_contrib, array(), 'published',	$_dracone['locale'], '', $_dracone['homepage'], 'disabled', array() );
	}


	// Insert a post COMMENT into post #1:
	// uses previous value of $now :)
	$query = "INSERT INTO T_comments( comment_post_ID, comment_type, comment_author,
			comment_author_email, comment_author_url, comment_author_IP,
			comment_date, comment_content, comment_karma)
		VALUES( 1, 'comment', 'Yabs', 'yabs@quamplures.net', 'http://quamplures.net', '127.0.0.1', '$now', '".
			$DB->escape( T_('Hi, this is a comment that has been approved.<br />To delete a comment, just log in, and view the posts\' comments, there you will have the option to edit or delete them.') ). "', 0 )";
	$DB->query( $query );


	// Insert a post into blog #4:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Bus Stop Ahead'), 'In the middle of nowhere: a school bus stop where you wouldn\'t really expect it!',
		$now, $cat_photo_album, array(), 'published','en-US', '', 'http://fplanque.com/photo/monument-valley' );
	// attach an image to the item
	$edit_File = new File( 'shared', 0, 'monument-valley/bus-stop-ahead.jpg' );
	$edit_File->link_to_Item( $edited_Item );


	// Insert a post into blog #4:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('John Ford Point'), 'Does this scene look familiar? You\'ve probably seen it in a couple of John Ford westerns!',
		$now, $cat_photo_album, array(), 'published','en-US', '', 'http://fplanque.com/photo/monument-valley' );
	// attach an image to the item
	$edit_File = new File( 'shared', 0, 'monument-valley/john-ford-point.jpg' );
	$edit_File->link_to_Item( $edited_Item );


	// Insert a post into blog #4:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Monuments'), 'This is one of the most famous views in Monument Valley. I like to frame it with the dirt road in order to give a better idea of the size of those things!',
		$now, $cat_photo_album, array(), 'published','en-US', '', 'http://fplanque.com/photo/monument-valley' );
	// attach an image to the item
	$edit_File = new File( 'shared', 0, 'monument-valley/monuments.jpg' );
	$edit_File->link_to_Item( $edited_Item );


	// Insert a post into blog #4:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Road to Monument Valley'), 'This gives a pretty good idea of the Monuments you\'re about to drive into...',
		$now, $cat_photo_album, array(), 'published','en-US', '', 'http://fplanque.com/photo/monument-valley' );
	// attach an image to the item
	$edit_File = new File( 'shared', 0, 'monument-valley/monument-valley-road.jpg' );
	$edit_File->link_to_Item( $edited_Item );


	// Insert a post into blog #4:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Monument Valley'), T_('This is a short photo album demo. Use the arrows to navigate between photos. Click on "Index" to see a thumbnail index.'),
		$now, $cat_photo_album, array(), 'published','en-US', '', 'http://fplanque.com/photo/monument-valley' );
	// attach an image to the item
	$edit_File = new File( 'shared', 0, 'monument-valley/monument-valley.jpg' );
	$edit_File->link_to_Item( $edited_Item );


	// Insert a post COMMENT into post #1:
	// uses previous value of $now :)
	$query = "INSERT INTO T_comments( comment_post_ID, comment_type, comment_status,
			comment_author, comment_author_email, comment_author_url, comment_author_IP, 
			comment_date, comment_content, comment_karma)
		VALUES( 1, 'comment', 'draft', 'EdB', 'edb@quamplures.net', 'http://quamplures.net', '127.0.0.1', '$now', '".
			$DB->escape( T_('Hi, this is a comment that is still in moderation, or "draft".<br />You are already logged in because you can see this, so all you have to do is change the visibility to "Published" to let visitors read this comment.') ). "', 0 )";
	$DB->query( $query );


	$info_page = /* TRANS: 1st %s: App name; 2nd %s: Blog name. */ T_('<p>This blog is powered by %s.</p>

<p>You are currently looking at an info page about %s. The post type is "Page".</p>

<p>Info pages are very much like regular posts, except that they do not appear in the regular flow of posts.</p>

<p>If needed, a template can format info pages differently from regular posts.</p>');


	// Insert a post PAGE into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('About Blog B'), sprintf( $info_page, $app_name, T_('Blog B') ),
		$now, $cat_ann_b,
		array(), 'published', '#', '', '', 'open', array('default'), 1000 );


	// Insert a post PAGE into blog #1:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('About Blog A'), sprintf( $info_page, $app_name, T_('Blog A') ),
		$now, $cat_welcome,
		array(), 'published', '#', '', '', 'open', array('default'), 1000 );


	// Insert a post PAGE into blog #1 (cross-posted):
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('About this system'), sprintf( T_('<p>This blog platform is powered by %s.</p>

<p>You are currently looking at an info page about this system. It is cross-posted among the demo blogs. Thus, this page will be linked on each of these blogs.</p>

<p>Cross-posting across multiple blogs is an advanced feature that is not on by default. The primary category is attached to blog #1, so clicking this link from any blog will display this item in blog #1.</p>

<p>Info pages use post type "Page" and are very much like regular posts, except that they do not appear in the regular flow of posts. You place them in a container using the "Simple Page list" widget.</p>

<p>If needed, a template can format info pages differently from regular posts. For example in a default installation, this template does not have a sidebar on "pages", or offer any feedback options.</p>'), $app_name ),
		$now, $cat_welcome, array( $cat_ann_b, $cat_linkblog_b2evo ), 'published', '#', '', '', 'open', array('default'), 1000 );
	// attach an image to the item
	$edit_File = new File( 'collection', 1, 'qp-logo_337x76.jpg' );
	$edit_File->link_to_Item( $edited_Item );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Sample Intro-Main post'), T_('This is the main intro post. It uses post type "Intro-Main" and appears on the homepage only. Your template can make these "intro" posts have a different look, and different features. For example this post does not show the date, author, categories, or allow any feedback.'),
		$now, $cat_appname, array(), 'published', '#', '', '', 'open', array('default'), 1500 );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, sprintf( T_('Sample Intro-Cat (sub-intro, %s tips category) post'), $app_name ), T_('This uses post type "Intro-Cat" and is attached to the desired Category(ies).'),
		$now, $cat_appname, array(), 'published', '#', '', '', 'open', array('default'), 1520 );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Sample Intro-Tag (sub-intro, Widgets tag) &ndash; post'), T_('This uses post type "Intro-Tag" and is tagged with the desired Tag(s).'),
		$now, $cat_appname, array(), 'published', '#', '', '', 'open', array('default'), 1530 );

	// Insert a post TAG for this post:
	$item_ID = $edited_Item->ID;
	$this_tag_id = $DB->get_var( "SELECT `tag_ID` FROM T_items__tag WHERE `tag_name` = 'widgets'" );
	if( ! $this_tag_id )
	{
		$tag_id_counter++;
		$this_tag_id = $tag_id_counter;
		$query = "INSERT INTO T_items__tag( tag_ID, tag_name ) VALUES( $this_tag_id, 'widgets' )";
		$DB->query( $query );
	}
	$query = "INSERT INTO T_items__itemtag( itag_itm_ID, itag_tag_ID ) VALUES( $item_ID, $this_tag_id )";
	$DB->query( $query );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Sample Intro-Sub post'), T_('This uses post type "Intro-Sub". I have no idea what that means or when it will show up.'),
		$now, $cat_appname, array( $cat_ann_b ), 'published', '#', '', '', 'open', array('default'), 1570 );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Sample Intro-All post'), T_('This uses post type "Intro-All".'),
		$now, $cat_appname, array( $cat_ann_b ), 'published', '#', '', '', 'open', array('default'), 1600 );


/*

leaving room for a sample post about toolbars

	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('XXXXXXXXXXXXXXXXXX'), sprintf( T_('foo %s bar'), $app_name ),
		$now, $cat_appname );


*/


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Comments'), ('<p>The comments section is really easy: for each post you get to decide if people can comment (open), if comments are no longer accepted (closed), or if comments simply aren\'t part of the post (disabled).  If you edit a post and select "disable" any comments that post already got will no longer be shown on the blog.</p>

<p>On your <code>Blog settings->Features</code> page you can set the default value for this field.</p>

<p>On your <code>Global settings->Plugins</code> page if you click on "Basic Antispam" you will be able to enable or disable anonymous comments.</p>'),
		$now, $cat_comments, array( $cat_writepage, $cat_sidebar ) );


	// Insert a post into blog #2:
	$localdoc = '<img src="'.$app_baseurl.'qp_rsc/icons/question.png" alt="Help" height="16" width="16">';
	$homepage = '<img src="'.$app_baseurl.'qp_rsc/icons/url.png" alt="WWW" height="16" width="32">';
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Text Renderers'), sprintf( T_('<p>Text renderers are really easy! They come from plugins and do stuff to your post content. The checkbox for each renderer is checked or not depending on the plugin\'s settings. On your <code>Global settings->Plugins</code> page if you click the name of the plugin you will be able to change the default condition.</p>

<p><strong>An example of how a renderer works:</strong> The "Smilies" plugin is off by default (which seems wrong to me but it is what it is). Therefore typing :) will NOT turn into a happy face. If I turn on that renderer then it will. Simple?</p>

<p>The post is stored exactly as you type it: rendering happens when the post is called for displaying in a browser, but not in the "write" screen when writing or editing.</p>

<p>Another example would be the code generated by the "Videos" plugin. You have a toolbar, you get code, the renderer makes it be a video. Edit this post to see the code :)</p>
<!--more-->
[video:vimeo:1124192 w:400 h:225]
<p>Each renderer might have 2 linked icons. The %s links to a readme file about the plugin/renderer and provides information about the plugin. The %s links to the plugin\'s home page where you might be able to learn more, or just thank the author for their work.</p>'), $localdoc, $homepage ),
		$now, $cat_renderers, array( $cat_writepage, $cat_sidebar ) );
	$edited_Item->set( 'renderers', array('video') );
	$edited_Item->dbsave();


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Visibility / Sharing'), sprintf( T_('<p>This section is all about who can see your post, and when, and where.</p>

<h3>Published</h3>
<p>A published post is visible to everyone who visits your blog. Publishing a post will trigger any pinging you may have enabled, and sets the displayed date and time of the post.</p>

<h3>Protected</h3>
<p>A protected post is only visible to people who are members of the blog the post is in and are logged in. You can use this to share information with a limited audience (blog members) in the usual post flow model. For example you might post about traffic data so your bloggers can react, but do not want that "out there" for all the world to see.</p>
<!--more-->
<h3>Private</h3>
<p>A private post is only visible to the author of the post, which seems silly to me. Why post something for you and only you to see? The only case I can think of for this is when you share a login with your significant other and want to "talk dirty" or post naughty pictures.</p>

<h3>Draft</h3>
<p>This is the default status for a new entry. Saving a draft in %s is just like saving a draft in many other applications: you start something, save it as a draft, and continue working on it later. <strong>When you are ready to publish your draft you should always use the "Publish NOW" button!</strong> If you edit the post and change the status it won\'t store the current date and time, or send out pings.</p>

<h3>Deprecated</h3>
<p>A deprecated post is deleted from the public side of the blog but not removed from the database. This is useful if you want to keep the information in the post, but it really doesn\'t need to be out there anymore.</p>

<h3>Redirected</h3>
<p>A redirected post is a strange case. Let\'s say after a while a certain post got so much attention that you decided to create a blog for that topic. You would put the new blog\'s URL in the "Link to URL" field and change the visibility to \'redirected\'. Visitors to the original permalink will now go straight to the content\'s new home.</p>'), $app_name ),
		$now, $cat_visibility, array( $cat_writepage, $cat_sidebar ) );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Properties'), T_('<p>The Properties section is kinda silly for the #2 spot in the sidebar. It contains 3 sections, one of which doesn\'t work, one of which you\'ll rarely ever use, and the last that I don\'t even know what it does.</p>

<p><strong>Featured post:</strong> this checkbox lets you make a post be "featured", which means it will show up on the top of the main blog page. It isn\'t supposed to show up in the post flow but it does. It should just go away.</p>

<p><strong>Update / Set issue date:</strong> This lets you edit the apparent date of an item. You can set it to "now", or any date and time you choose.</p>

<p><strong>Order:</strong> When you figure it out let us know okay?</p>'),
		$now, $cat_properties, array( $cat_writepage, $cat_sidebar ) );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Categories'), T_('<p>Categories are fairly simple. You create categories for each blog on your <code>Blog settings->Categories</code> page, then select which category/categories each post will be in.</p>

<p>Each post needs to have a "Main" category selected by clicking the radio button. Additionally you can assign "Extra" categories to a post by clicking the checkbox for each one.</p>

<p>Visitors can use categories to help find content they\'re into reading.</p>'),
		$now, $cat_categories, array( $cat_writepage, $cat_sidebar ) );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Advanced Properties'), sprintf( T_('<h3>URL title "slug":</h3>
<p>The URL title slug is used as part of each item\'s permalink, and will be automatically created from your post Title. You can over-ride creation by supplying your own. You may want to do this if your post title is very long, or contains special characters. You can change your configuration to not use this feature but the "slug" will always be created anyway.</p>

<h3>Tags:</h3>
<p>Tags allow a different way to let visitors find content on your site. Think of them as "categories on the fly" because you can write as many or few tags as you want based on what your blog post is about.</p>

<h3>&lt;title> tag:</h3>
<p>This field lets you create your own title displayed at the top of the browser. If you leave this field blank then %s will use the item title as the browser page title.</p>
<!--more-->
<h3>&lt;meta> desc:</h3>
<p>This field lets you create your own "description meta tag" for the permalink\'s &lt;head> section. Some think this will help search engine placement, others doubt it. If you leave this field blank then %s will use the blog\'s description field.</p>

<h3>&lt;meta> keywds:</h3>
<p>This field lets you create your own "keywords meta tag" for the permalink\'s &lt;head> section. Some think this will help search engine placement, others doubt it. If you leave this field blank then %s will use the blog\'s keywords field.</p>

<h3>Excerpt:</h3>
<p>Excerpt is like a box of chocolates: if you leave it in the car everything will get all melty unless it is the middle of winter. Then they\'ll all freeze.</p>'), $app_name, $app_name, $app_name ),
		$now, $cat_advanced, array( $cat_writepage, $cat_mainbody ) );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Images &amp; Attachments'), sprintf( T_('<p>This post is about the "Images & Attachments" section of the write page. Images can also be \'inserted\' into a post. This entry does not cover that.</p>

<p>Attaching a file to an item (your post) is similar to attaching a file to an email. In %s if you attach an image it will also be resized if required to fit your template and displayed at the top of your post. You can attach as many images to a post as you like, but all will be displayed at the top of the post.</p>

<p>Attaching an image takes advantage of the fields available when you enable \'advanced upload properties\' on the upload page. Each attached image will use the long title and alternative text in the IMG tag, and display the description/caption under the image. That means you can, effectively, write your blog post entries straight from the file manager by uploading and providing a good title, alt text and caption, then selecting your images and choosing the "make multiple posts" option.</p>
<!--more-->
<p>Templates can resize images from 80 to 800 pixels wide, in 40 pixel increments. Width x Height proportionality is maintained. Your template can use one size in the sidebar, another in the main body, and a third for the item\'s permalink page. Attached images can be linked to the original, another resized version of the image (in a popup window), the item\'s permalink, or nothing.</p>

<p>If you attach a non-image file (.doc, .xls, .ppt, .zip, etcetera) the file will be made available to your visitors as a link. What happens with that link depends on the visitors browser and computer.</p>'), $app_name ),
		$now, $cat_images, array( $cat_writepage, $cat_mainbody ) );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Post contents'), sprintf( T_('<p>The Post contents section is the easiest to figure out. Sort of...</p>

<p><strong>Title:</strong> This is the title of your post. Pretty easy eh? On your <code>Blog settings->Features</code> page you can make titles optional or not allowed (hide the field). The default for that setting is "required".</p>

<p><strong>Link to url:</strong> This one is a little confusing. IF you want to associate a web page with your post you would paste in the URL here. On your <code>Blog settings->URLs</code> page you can tell %s to link the title to this URL if you provide one. Your template can display it as "Link: what_you_put_in_link-to-url", like in this post for example.</p>

<p><strong>Type:</strong> This one is a lot confusing. Most of your posts will use the post type "Post" which is the default, but there are quite a few options. Some of which are probably dumb.</p>
<!--more-->
<ul>
<li>Page: this is for informational items that are not part of the normal blog post flow but you do want listed on your web. For example the traditional "About Me" page would be a post using type=page. These items can be placed with a widget, such as the "About this system" link above.</li>
<li>Intro-Main, Intro-Cat, Intro-Tag, Intro-Sub, Intro-All: each of these is covered by it\'s own sample so no sense in re-writing it all here.</li>
<li>Podcast: this is a special case that will call up an audio player if you have a link to an audio file in your "link to url" field. Your template can display the player anywhere but will typically put it above the post text.</li>
<li>Sidebar link: heck I dunno what this one does. I\'m thinking it probably puts links in the sidebar, but really that means it puts links in a widget that you might put in the sidebar container.</li>
</ul>'), $app_name ),
		$now, $cat_contents, array( $cat_writepage, $cat_mainbody ), 'published','en-US', '', 'http://forums.quamplures.net/' );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Featured post'), T_('<p>This is a demo of a featured post. The post type is "Post" (default) and the "Featured post" checkbox is checked.</p>

<p>It will be featured whenever we have no specific "Intro" post to display for the current request. To see it in action, try displaying the "Announcements" category.</p>

<p>A featured post can be thought of as a "sticky post". Also note that when the post is featured, it does not appear in the regular post flow.</p>'),
		$now, $cat_appname, array( $cat_ann_b ) );
	$edited_Item->set( 'featured', 1 );
	$edited_Item->dbsave();


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Apache optimization...'), sprintf( T_('<p>In the %s root folder there is a file called [<code>sample.htaccess</code>]. It is designed to optimize the way %s is handled by your (Apache) webserver.</p>

<p>If you are experiencing problems with %s and you do not already have a file named <code>.htaccess</code> you might want to rename sample.htacess to .htacess and see if it helps.</p>

<p><strong>WARNING:</strong> you might already have a .htaccess file and not see it because your FTP client is hiding files that begin with a dot.<br /><strong>WARNING:</strong> some features your host offers will depend on your host writing your .htacces file, so renaming this sample might cause other problems.</p>

<p>If you are unsure about what these warnings mean either talk to your host first or do not consider renaming your sample.htaccess file.</p>
<!--more-->
<p>Some of the things sample.htaccess can do for you:</p>

<ul>
<li>PHP SECURITY: turns register globals off in the %s directory</li>
<li>DEFAULT DOCUMENT TO DISPLAY: serves index.php over index.html to non-specific requests</li>
<li>CLEAN URLS: something to try if you\'re using Apache 2 and clean URLs don\'t work</li>
</ul>'), $app_name, $app_name, $app_name, $app_name ),
		$now, $cat_appname, array( $cat_ann_b ) );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Stubs, Templates &amp; website integration...'),
							sprintf( T_('<p>By default, blogs are displayed using a template. A template is a set of files that defines what shows up on your blog and how it looks. (More on templates in another post.)</p>

<p>In a default installation, blogs are accessed through a stub file with "clean URLs" enabled. Your server may not support clean URLs. If not you will need to change your <code>Blog settings->URLs</code> selections to "Use params" ... or change hosts. A stub file must define which blog will be called, and can optionally force other parameters (template, category/categories, date range, display order, others). In the URL of this page "blog2.php" is a a stub file in the installation\'s root directory.</p>
 
<p>You can use a stub file even if clean URLs do not work on your server. For example the following URLs all point to the same page: blog #2 displaying posts in the "announcements" category.</p>
<!--more-->
<ul>
<li><code>htp://yourdomain.com/blog2.php/announcements/</code></li>
<li><code>htp://yourdomain.com/blog2.php?cat=4</code></li>
<li><code>htp://yourdomain.com/index.php?blog=2&amp;cat=4</code></li>
</ul>

<p>7 stub files for your first 7 blogs are provided, and you can use \'<code>a_stub.php</code>\' for any additional blogs. Simply edit the file and change <code>$blog = 1;</code> to the blog ID number.</p>

<p>Finally, if you need to do some very specific customizations to your blog, you may want to call your blog through the \'<code>a_notemplate.php</code>\' file. On your <code>Global settings->General</code> page select which blog to display, then on that blog\'s <code>Blog settings->URLs</code> page put the file name in the box for "Relative to baseurl". Or delete the existing index.php file and rename no_template.php to index.php and select "Default blog in index.php".</p>

<p>If you want to integrate a %s blog into a complex website, you\'ll probably want to do it by copy/pasting code from <code>a_notemplate.php</code> into a page of your website.</p>

<p>You will find more information in the stub/template files themselves. Open them in a text editor and read the comments in there.</p>

<p>Either way, make sure you go to the blogs admin and set the correct access method/URL for your blog. Otherwise, the permalinks will not function properly.</p>'), $app_name ),
		$now, $cat_appname );

	// Insert a post TAG for this post:
	$item_ID = $edited_Item->ID;
	$this_tag_id = $DB->get_var( "SELECT `tag_ID` FROM T_items__tag WHERE `tag_name` = 'templates'" );
	if( ! $this_tag_id )
	{
		$tag_id_counter++;
		$this_tag_id = $tag_id_counter;
		$query = "INSERT INTO T_items__tag( tag_ID, tag_name ) VALUES( $this_tag_id, 'templates' )";
		$DB->query( $query );
	}
	$query = "INSERT INTO T_items__itemtag( itag_itm_ID, itag_tag_ID ) VALUES( $item_ID, $this_tag_id )";
	$DB->query( $query );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('About widgets...'), sprintf( T_('<p>%s blogs are installed with a default selection of Widgets. For example, the sidebar of this blog includes widgets like a calendar, a search field, a list of categories, a list of XML feeds, etc.</p>

<p>You can add, remove and reorder widgets from the "Blog Settings -> widgets" section in the admin interface.</p>

<p>Widgets are placed in containers. Each container appears in a specific place in a template. If you change your blog template, the new template may not use the same containers as the previous one. Make sure you place your widgets in containers that exist in the specific template you are using.</p>

<p>Widgets can also be "hard-coded" into your template. If you know that you always want a certain widget in a certain place, forcing it through your template is a good idea.</p>
'), $app_name ),
		$now, $cat_appname );

	// Insert a post TAG for this post:
	$item_ID = $edited_Item->ID;
	$this_tag_id = $DB->get_var( "SELECT `tag_ID` FROM T_items__tag WHERE `tag_name` = 'widgets'" );
	if( ! $this_tag_id )
	{
		$tag_id_counter++;
		$this_tag_id = $tag_id_counter;
		$query = "INSERT INTO T_items__tag( tag_ID, tag_name ) VALUES( $this_tag_id, 'widgets' )";
		$DB->query( $query );
	}
	$query = "INSERT INTO T_items__itemtag( itag_itm_ID, itag_tag_ID ) VALUES( $item_ID, $this_tag_id )";
	$DB->query( $query );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('About templates...'), sprintf( T_('<p>By default, %s blogs are displayed using a template.</p>

<p>You can change the template used by any blog by editing the blog settings in the admin interface.</p>

<p>You can download additional template from the <a href="http://templates.quamplures.net/" target="_blank">templates site</a>. To install them, unzip them in the /blogs/qp_templates directory, then go to General Settings &gt; Templates in the admin interface and click on "Install new".</p>

<p>You can also create your own templates by duplicating, renaming and customizing any existing template folder from the /blogs/qp_templates directory.</p>

<p>To start customizing a template, open its "<code>index.main.php</code>" file in an editor and read the comments in there. Note: you can also edit templates in the "Files" tab of the admin interface if you enable template directories (Global settings, Files sub-section).</p>

<p>You might also want to read the <a href="http://codex.quamplures.net/templates.php" target="_blank">manual</a> or <a href="http://docs.quamplures.net/templates/tutorial_templates.pkg.html" target="_blank">autodocs</a> on templates.</p>'), $app_name ),
		$now, $cat_appname );

	// Insert a post TAG for this post:
	$item_ID = $edited_Item->ID;
	$this_tag_id = $DB->get_var( "SELECT `tag_ID` FROM T_items__tag WHERE `tag_name` = 'templates'" );
	if( ! $this_tag_id )
	{
		$tag_id_counter++;
		$this_tag_id = $tag_id_counter;
		$query = "INSERT INTO T_items__tag( tag_ID, tag_name ) VALUES( $this_tag_id, 'templates' )";
		$DB->query( $query );
	}
	$query = "INSERT INTO T_items__itemtag( itag_itm_ID, itag_tag_ID ) VALUES( $item_ID, $this_tag_id )";
	$DB->query( $query );






	// Insert a post into blog #1:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Inserted Image post'), T_('<p><span class="imgwrap floatright center"><img src="'.$app_baseurl.'media/blogs/id_1/waterfall.jpg" alt="waterfall" title="waterfall" width="160" height="240" class="spanimage" /><br /><span class="image_legend">waterfall</span></span> This waterfall image was re-sized before uploading, then uploaded using the <strong>quick upload</strong> feature. Therefore the file name is also the title, alt text, and image caption. You can customize those details and even rename the file when you upload it if you use <strong>advanced upload properties</strong>, which is discussed in a different post.</p>

<p>This image is floated to the right which is why the text flows alongside and under the image.  When you insert an image you can float it right, or left, or have it centered in a &lt;div&gt; if you like.</p>

<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse ac tellus nisl; ut bibendum ante. Suspendisse ac odio sit amet nibh ultricies semper at id lorem. Suspendisse faucibus pretium ullamcorper. Nam congue est ut nunc malesuada pellentesque.</p>

<p>Image used compliments of <a href="http://www.flickr.com/photos/leeturner/sets/72157622986782395/with/4278672768/" title="inserted image sample">Lee Turner</a></p>'),
		$now, $cat_post_features );

	// attach an image to the item
	$edit_File = new File( 'collection', 1, 'waterfall.jpg' );
	$edit_File->link_to_Item( $edited_Item );
	// add meta data for this image (only once per image!)
	$query = "UPDATE T_files
		SET file_title = 'waterfall', file_alt = 'waterfall', file_desc = 'waterfall'
		WHERE file_ID = {$edit_File->ID}";
	$DB->query( $query );
	// now break the attachment
	$query = "DELETE FROM T_links WHERE link_itm_ID = {$edited_Item->ID}";
	$DB->query( $query );



	// Insert a post into blog #1:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Attached Image post'), T_('<p>This post has an image attached (or linked) to it. Attaching an image will automatically resize it to fit the current template. Automatic resizing is based on width, with sizes from 80 to 800 pixels wide.</p>
<!--more-->
<p>You can create a template that will resize an image to 240 pixels wide in the sidebar, 400 wide in the main body on multipost pages, and 600 wide on the item\'s permalink page. Neato eh?</p>

<p>In this template the attached image is linked to the original version. You can edit your template to link the image to a larger resized version, the post\'s permalink, or nothing.</p>

<p>Check out the photoblog (accessible through the links at the top) to see a completely different template focused more on the photos than on the blog text.</p>

<p>This file was uploaded using the <strong>advanced upload properties</strong> which allows for customizing the title and alt text and description (also called caption).</p>

<p>Image used compliments of <a href="http://innervisions.org.uk/bimble/2008/08/sunshine-and-showers" title="attached image sample">Yabs</a></p>'),
		$now, $cat_post_features );

	// attach an image to the item
	$edit_File = new File( 'collection', 1, 'sunshine_and_flowers.jpeg' );
	$edit_File->link_to_Item( $edited_Item );
	// add meta data for this image (do once per default image!)
	$query = "UPDATE T_files
		SET file_title = 'home grown flowers', file_alt = 'home grown flowers', file_desc = 'Coral Jupiter'
		WHERE file_ID = {$edit_File->ID}";
	$DB->query( $query );





	// Insert a post into blog #1:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('This is a multipage post'), T_('<p>This is page 1 of a multipage post. You can see the other pages by clicking on the links below the text.</p>
<!--nextpage-->
<p>This is page 2. This feature uses the "!NP" button on the Quick Tags toolbar. You can add as many pages as you want.</p>
<!--nextpage-->
<p>This is third and final page. This page demonstrates some other features of the Quick Tags toolbar.</p>

<p><ins>This sentence is wrapped with the "ins" (insert) button.</ins> <del>This sentence is wrapped with the "del" (delete) button.</del> <strong>This sentence is wrapped with the "str" (strong/bold) button.</strong> <em>This sentence is wrapped with the "em" (emphasize/italic) button.</em> <code>This sentence is wrapped with the "code" button.</code></p>

<p>The styles for these buttons can be changed in your template\'s style sheet.</p>'),
		$now, $cat_post_features );


	// Insert a post into blog #1:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Extended post with no teaser'), T_('<p>This is an extended post with no teaser. This means that you won\'t see this teaser any more when you click the "more &raquo;" link (or the item\'s permalink).</p>
<!--noteaser-->
<p>This is the extended text. You only see it when you have clicked the "more &raquo;" link, and you no longer see the "teaser" portion of this post. This feature uses the "!NT" button on the Quick Tags toolbar.</p>

<p>By editing your template you will be able to change both "more &raquo;" and "Follow up:" to suit your tastes, but the changes will apply to all features that create a "more" link.</p>'),
		$now, $cat_post_features );


	// Insert a post into blog #1:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, T_('Extended post'), T_('<p>This is an extended post. This means you only see this small teaser on a multi-post page, and must click on the link below (or the permalink) to see more.</p>
<!--more-->
<p>This is the extended text. You only see it when you have clicked the "more &raquo;" link. This feature uses the "!M" button on the Quick Tags toolbar. You decide where you want the link, if at all.</p>

<p>By editing your template you will be able to change both "more &raquo;" and "Follow up:" to suit your tastes.</p>'),
		$now, $cat_post_features );


	// Insert a post into blog #2:
	$now = date('Y-m-d H:i:s',installer_timestamp());
	$edited_Item = new Item();
	$edited_Item->insert( 1, sprintf( T_('Welcome to %s!'), $app_name ), sprintf( T_('<p>Four blogs have been created with sample contents:</p>

<ul>
<li><strong>Blog A</strong>: You are currently looking at it. It contains a few sample posts, using simple features of %1$s. For example this post has an unordered list and bold text.</li>
<li><strong>Blog B</strong>: You can access it from a link at the top of the page. It contains information about more advanced features such as posting features and "intro-type" posts.</li>
<li><strong>Linkblog</strong>: By default, the linkblog is included as a "Blogroll" in the sidebar of both Blog A &amp; Blog B. The default linkblog contains names and links of the people who helped create this version of QP.</li>
<li><strong>Photoblog</strong>: This blog is an example of how you can use %1$s to showcase photos, with one photo per page as well as a thumbnail index.</li>
</ul>

<p>You can add new blogs, delete unwanted blogs and customize existing blogs (title, sidebar, blog template, widgets, etc.) from the Blog Settings tab in the admin interface.</p>

<p>We strongly suggest you read through these sample posts - especially Blog B - to get an idea of how this whole thing works. Also, after reading you might want to change the "Visibility / Sharing" from \'Published\' to \'Deprecated\' instead of deleting them.</p>'), $app_name ),
		$now, $cat_welcome );
	// attach an image to the item
	$edit_File = new File( 'collection', 1, 'qp-logo_337x76.jpg' );
	$edit_File->link_to_Item( $edited_Item );

	echo "OK.<br />\n";


	echo 'Creating default group/blog permissions... ';
	// Admin for blog A:
	$query = "
		INSERT INTO T_coll_group_perms( bloggroup_blog_ID, bloggroup_group_ID, bloggroup_ismember,
			bloggroup_perm_poststatuses, bloggroup_perm_delpost, bloggroup_perm_comments,
			bloggroup_perm_cats, bloggroup_perm_properties,
			bloggroup_perm_media_upload, bloggroup_perm_media_browse, bloggroup_perm_media_change )
		VALUES
			( $blog_a_ID, ".$Group_Admins->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 1, 1, 1, 1, 1 ),
			( $blog_a_ID, ".$Group_Special->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 0, 0, 1, 1, 1 ),
			( $blog_a_ID, ".$Group_Bloggers->ID.", 1, 'published,deprecated,protected,private,draft', 0, 0, 0, 0, 1, 1, 0 ),
			( $blog_a_ID, ".$Group_Users->ID.", 1, '', 0, 0, 0, 0, 0, 0, 0 ),
			( $blog_b_ID, ".$Group_Admins->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 1, 1, 1, 1, 1 ),
			( $blog_b_ID, ".$Group_Special->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 0, 0, 1, 1, 1 ),
			( $blog_b_ID, ".$Group_Bloggers->ID.", 1, 'published,deprecated,protected,private,draft', 0, 0, 0, 0, 1, 1, 0 ),
			( $blog_b_ID, ".$Group_Users->ID.", 1, '', 0, 0, 0, 0, 0, 0, 0 ),
			( $blog_linkblog_ID, ".$Group_Admins->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 1, 1, 1, 1, 1 ),
			( $blog_linkblog_ID, ".$Group_Special->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 0, 0, 1, 1, 1 ),
			( $blog_linkblog_ID, ".$Group_Bloggers->ID.", 1, 'published,deprecated,protected,private,draft', 0, 0, 0, 0, 1, 1, 0 ),
			( $blog_linkblog_ID, ".$Group_Users->ID.", 1, '', 0, 0, 0, 0, 0, 0, 0 )";
	$DB->query( $query );
	echo "OK.<br />\n";

	/*
	// Note: we don't really need this any longer, but we might use it for a better default setup later...
	echo 'Creating default user/blog permissions... ';
	// Admin for blog A:
	$query = "INSERT INTO T_coll_user_perms( bloguser_blog_ID, bloguser_user_ID, bloguser_ismember,
							bloguser_perm_poststatuses, bloguser_perm_delpost, bloguser_perm_comments,
							bloguser_perm_cats, bloguser_perm_properties,
							bloguser_perm_media_upload, bloguser_perm_media_browse, bloguser_perm_media_change )
						VALUES
							( $blog_a_ID, ".$User_Demo->ID.", 1,
							'published,deprecated,protected,private,draft', 1, 1, 0, 0, 1, 1, 1 )";
	$DB->query( $query );
	echo "OK.<br />\n";
	*/


	install_basic_widgets();

}


?>
