<?php
/**
 * This file implements the AutoLinks plugin for Quam Plures
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 *
 * @package plugins
 * @subpackage AutoLinks
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );


/**
 * @package plugins
 * @subpackage AutoLinks
 */
class autolinks_plugin extends Plugin
{
	var $apply_rendering = 'opt-out';
	var $code = 'autolinks';
	var $group = 'renderers';
	var $number_of_installs = 1;
	var $priority = 60;
	var $version = '0.1';


	/**
	 * @see Plugin::PluginInit()
	 */
	function PluginInit( & $params )
	{
		$this->name = $this->T_('Auto Links');
		$this->short_desc = T_('Automatically turn URLs in your post into links.');
		$this->long_desc = T_('This renderer automatically creates links for you when you paste a URL into your blog post.');
	}


	/**
	 * @see Plugin::RenderItemAsHtml()
	 */
	function RenderItemAsHtml( & $params )
	{
		$content = & $params['data'];
		$content = make_clickable( $content );
		return true;
	}

}

?>
