<?php
/**
 * This file implements the Break Video class of the video plugin for Quam Plures
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2010 by the Quam Plures developers - {@link http://quamplures.net/}
 *
 * @package plugins
 * @subpackage video
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * Break Video Class
 *
 * @package plugins
 * @subpackage video
 */
class vp_break extends vp_video {

	var $nice_name = 'Break';
	var $homepage = 'http://break.com';


	/**
	 * source-specific javascript
	 */
	function GetJavascript()
	{
		/**
		 * Sample embed :
		 * <object width="464" height="376" id="1758195" type="application/x-shockwave-flash" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" alt="Girlfriend Sneak-Attacked With Exercise Ball Funny Videos"><param name="movie" value="http://embed.break.com/MTc1ODE5NQ=="></param><param name="allowScriptAccess" value="always"></param><embed src="http://embed.break.com/MTc1ODE5NQ==" type="application/x-shockwave-flash" allowScriptAccess=always width="464" height="376"></embed></object><br><font size=1><a href="http://www.break.com/index/girlfriend-sneak-attacked-with-exercise-ball.html" target="_blank">Girlfriend Sneak-Attacked With Exercise Ball</a> - Watch more <a href="http://www.break.com/" target="_blank">Funny Videos</a></font>
		 */
		$r = <<<JAVASCRIPT
var regex = new RegExp( '^.+?width="([0-9]+?)" height="([0-9]+?)".+?http://embed.break.com/([^"]+?)".+?$' );
if( vid_code.match( regex ) ) {
	return '[video:break:'+vid_code.replace( regex, '$3 w:$1 h:$2' )+']';
} else {
	return false;
}
JAVASCRIPT;
return $r;
	}


	/**
	 * supports RenderItemAsHtml() in _video.plugin.php
	 */
	function RenderContent( $content, $width )
	{
		if( strpos($content,'[video:break') !== false )
		{
			$content = preg_replace( '#\[video:break:(.+?) w:(.+?) h:(.+?)]#', '<div class="videoblock"><object type="application/x-shockwave-flash" data="http://embed.break.com/\\1" [breakscale:\\2:\\3]><param name="movie" value="http://embed.break.com/\\1" /><param name="allowfullscreen" value="true" /><param name="wmode" value="transparent" /></object></div>', $content );
			while( substr( $content,strpos($content,'[breakscale') +12,3 ) > 0 )
			{
				$orig_height = substr($content,strpos($content,'[breakscale')+16,3);
				$orig_width = substr($content,strpos($content,'[breakscale')+12,3);
				$height = round( ( $width * $orig_height ) / $orig_width );
				$content = preg_replace( '#\[breakscale:(.+?)]#', 'width="'.$width.'" height="'.$height.'"', $content, $limit= 1 );
			}
		}
		return $content;
	}
}
?>
