<?php
/**
 * This file implements the College Humor Video class of the video plugin for Quam Plures
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2010 by the Quam Plures developers - {@link http://quamplures.net/}
 *
 * @package plugins
 * @subpackage video
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * College Humor Video Class
 *
 * @package plugins
 * @subpackage video
 */
class vp_collegehumor extends vp_video {

	var $nice_name = 'College Humor';
	var $homepage = 'http://www.collegehumor.com/videos';
	var $def_value = 0;


	/**
	 * source-specific javascript
	 */
	function GetJavascript()
	{
		/**
		 * Sample embed :
		 * <object type="application/x-shockwave-flash" data="http://www.collegehumor.com/moogaloop/moogaloop.swf?clip_id=1929571&fullscreen=1" width="640" height="360" ><param name="allowfullscreen" value="true"/><param name="wmode" value="transparent"/><param name="allowScriptAccess" value="always"/><param name="movie" quality="best" value="http://www.collegehumor.com/moogaloop/moogaloop.swf?clip_id=1929571&fullscreen=1"/><embed src="http://www.collegehumor.com/moogaloop/moogaloop.swf?clip_id=1929571&fullscreen=1" type="application/x-shockwave-flash" wmode="transparent"  width="640" height="360"  allowScriptAccess="always"></embed></object><div style="padding:5px 0; text-align:center; width:640px;">See more <a href="http://www.collegehumor.com/videos">funny videos</a> and <a href="http://www.collegehumor.com/pictures">funny pictures</a> at <a href="http://www.collegehumor.com/">CollegeHumor</a>.</div>
		 */
		$r = <<<JAVASCRIPT
var regex = new RegExp( '^.+?http://www\.collegehumor\.com/.+?clip_id=(.+?)&.+?width="([0-9]+?)" height="([0-9]+?)".+?$' );
if( vid_code.match( regex ) ) {
	return '[video:college:'+vid_code.replace( regex, '$1 w:$2 h:$3' )+']';
} else {
	return false;
}
JAVASCRIPT;
return $r;
	}


	/**
	 * supports RenderItemAsHtml() in _video.plugin.php
	 */
	function RenderContent( $content, $width )
	{
		if( strpos($content,'[video:college') !== false )
		{
			$content = preg_replace( '#\[video:college:(.+?) w:(.+?) h:(.+?)]#', '<div class="videoblock"><object type="application/x-shockwave-flash" data="http://www.collegehumor.com/moogaloop/moogaloop.swf?clip_id=\\1" [collgscale:\\2:\\3]><param name="movie" value="http://www.collegehumor.com/moogaloop/moogaloop.swf?clip_id=\\1" /><param name="allowfullscreen" value="true" /><param name="wmode" value="transparent" /></object></div>', $content );
			while( substr( $content,strpos($content,'[collgscale') +12,3 ) > 0 )
			{
				$orig_height = substr($content,strpos($content,'[collgscale')+16,3);
				$orig_width = substr($content,strpos($content,'[collgscale')+12,3);
				$height = round( ( $width * $orig_height ) / $orig_width );
				$content = preg_replace( '#\[collgscale:(.+?)]#', 'width="'.$width.'" height="'.$height.'"', $content, $limit= 1 );
			}
		}
		return $content;
	}
}
?>
