<?php
/**
 * This file implements the Dailymotion Video class of the video plugin for Quam Plures
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2010 by the Quam Plures developers - {@link http://quamplures.net/}
 *
 * @package plugins
 * @subpackage video
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * Dailymotion Video Class
 *
 * @package plugins
 * @subpackage video
 */
class vp_dailymotion extends vp_video {

	var $nice_name = 'Dailymotion';
	var $homepage = 'http://www.dailymotion.com';


	/**
	 * source-specific javascript
	 */
	function GetJavascript()
	{
		/**
		 * Sample embed :
		 * <object width="480" height="275"><param name="movie" value="http://www.dailymotion.com/swf/xbugwc"></param><param name="allowFullScreen" value="true"></param><param name="allowScriptAccess" value="always"></param><embed type="application/x-shockwave-flash" src="http://www.dailymotion.com/swf/xbugwc" width="480" height="275" allowfullscreen="true" allowscriptaccess="always"></embed></object><br /><b><a href="http://www.dailymotion.com/video/xbugwc_crookers-remedy-ft-miike-snow_music">CROOKERS - REMEDY - FT. MIIKE SNOW</a></b><br /><i>Uploaded by <a href="http://www.dailymotion.com/SouthernFriedRecords">SouthernFriedRecords</a>. - <a href="http://www.dailymotion.com/gb/channel/music">Explore more music videos.</a></i>
		 */
		$r = <<<JAVASCRIPT
var regex = new RegExp( '^.+?http:\/\/www\.dailymotion\.com\/swf\/([^"]+?)".+?width="([0-9]+?)" height="([0-9]+?)".+?$' );
if( vid_code.match( regex ) ) {
	return '[video:daily:'+vid_code.replace( regex, '$1 w:$2 h:$3' )+']';
} else {
	return false;
}
JAVASCRIPT;
return $r;
	}


	/**
	 * supports RenderItemAsHtml() in _video.plugin.php
	 */
	function RenderContent( $content, $width )
	{
		if( strpos($content,'[video:daily:') !== false )
		{
			$content = preg_replace( '#\[video:daily:(.+?) w:(.+?) h:(.+?)]#', '<div class="videoblock"><object type="application/x-shockwave-flash" data="http://www.dailymotion.com/swf/\\1" [dailyscale:\\2:\\3]><param name="movie" value="http://www.dailymotion.com/swf/\\1" /><param name="allowfullscreen" value="true" /><param name="wmode" value="transparent" /></object></div>', $content );
			while( substr( $content,strpos($content,'[dailyscale') +12,3 ) > 0 )
			{
				$orig_height = substr($content,strpos($content,'[dailyscale')+16,3);
				$orig_width = substr($content,strpos($content,'[dailyscale')+12,3);
				$height = round( ( $width * $orig_height ) / $orig_width );
				$content = preg_replace( '#\[dailyscale:(.+?)]#', 'width="'.$width.'" height="'.$height.'"', $content, $limit= 1 );
			}
		}
		return $content;
	}
}
?>
