<?php
/**
 * This file implements the Live Video class of the video plugin for Quam Plures
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2010 by the Quam Plures developers - {@link http://quamplures.net/}
 *
 * @package plugins
 * @subpackage video
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * Live Video Class
 *
 * @package plugins
 * @subpackage video
 */
class vp_livevideo extends vp_video {

	var $nice_name = 'LiveVideo';
	var $homepage = 'http://www.livevideo.com/';


	/**
	 * source-specific javascript
	 */
	function GetJavascript()
	{
		/**
		 * Sample embed :
		 * <div><embed src="http://www.livevideo.com/flvplayer/embed/7531304631DA49D7821C721923C045CB&autoStart=1" type="application/x-shockwave-flash" quality="high" WIDTH="445" HEIGHT="369" wmode="transparent"></embed><br/><a href="http://www.livevideo.com/video/embedLink/7531304631DA49D7821C721923C045CB/1205207/shark-lip-sync.aspx">SHARK LIP SYNC</a></div>
		 *
		 * Sample url :
		 * http://www.livevideo.com/video/TheASYLUM/7531304631DA49D7821C721923C045CB/shark-lip-sync.aspx
		 */
		$r = <<<JAVASCRIPT
var regex = new RegExp( '^.+?www\.livevideo\.com\/.+?embed\/(.+?)&.+?width="([0-9]+?)" height="([0-9]+?)".+?$', 'i' );
var regexUrl = new RegExp( '^.+?www\.livevideo\.com\/([^\/]+?\/){2}([^\/]+?)\/.+?$' );
if( vid_code.match( regex ) ) {
	return '[video:livevideo:'+vid_code.replace( regex, '$1 w:$2 h:$3' )+']';
} else if( vid_code.match( regexUrl ) ) {
	return '[video:livevideo:'+vid_code.replace( regexUrl, '$2' )+']';
} else {
	return false;
}
JAVASCRIPT;
return $r;
	}


	/**
	 * supports RenderItemAsHtml() in _video.plugin.php
	 */
	function RenderContent( $content, $width )
	{
		if( strpos($content,'[video:livevideo') !== false )
		{
			$content = preg_replace( '#\[video:livevideo:(.+?)(:w:([0-9]+?) h:([0-9]+?))?]#', '<div class="videoblock"><object type="application/x-shockwave-flash" data="http://www.livevideo.com/flvplayer/embed/\\1" [lvid:369]><param name="movie" value="http://www.livevideo.com/flvplayer/embed/\\1" /><param name="allowfullscreen" value="true" /><param name="wmode" value="transparent" /></object></div>', $content );
			$content = preg_replace( '#\[lvid:(.+?)]#', 'width="'.$width.'" height="'.round( ( $width * substr($content,strpos($content,'[lvid')+6,3) ) / 445 ).'"', $content );
		}
		return $content;
	}
}
?>
