<?php
/**
 * This file implements the Revver Video class of the video plugin for Quam Plures
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2010 by the Quam Plures developers - {@link http://quamplures.net/}
 *
 * @package plugins
 * @subpackage video
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * Revver Video Class
 *
 * @package plugins
 * @subpackage video
 */
class vp_revver extends vp_video {

	var $nice_name = 'Revver';
	var $homepage = 'http://revver.com';


	/**
	 * source-specific javascript
	 */
	function GetJavascript()
	{
		/**
		 * Sample embed :
		 * <object width="480" height="392" data="http://flash.revver.com/player/1.0/player.swf?mediaId=2132992" type="application/x-shockwave-flash" id="revvervideoa17743d6aebf486ece24053f35e1aa23"><param name="Movie" value="http://flash.revver.com/player/1.0/player.swf?mediaId=2132992"></param><param name="FlashVars" value="allowFullScreen=true"></param><param name="AllowFullScreen" value="true"></param><param name="AllowScriptAccess" value="always"></param><embed type="application/x-shockwave-flash" src="http://flash.revver.com/player/1.0/player.swf?mediaId=2132992" pluginspage="http://www.macromedia.com/go/getflashplayer" allowScriptAccess="always" flashvars="allowFullScreen=true" allowfullscreen="true" height="392" width="480"></embed></object>
		 *
		 * Sample script :
		 * <script src="http://flash.revver.com/player/1.0/player.js?mediaId:2132992;width:480;height:392;" type="text/javascript"></script>
		 *
		 * Sample Url :
		 * http://revver.com/video/2132992/family-dentist-omahadentist-in-omahacosmetic-dentist-omaha-ne/
		 *
		 */
		$r = <<<JAVASCRIPT
var regex = new RegExp( '^.+?width="([0-9]+?)" height="([0-9]+?)".+?flash\.revver\.com\/.+?mediaid=([0-9]+?)".+?$', 'i' );
var regexScript = new RegExp( '^.+?flash\.revver\.com\/.+?mediaid:([0-9]+?);width:([0-9]+?);height:([0-9]+?);.+?$', 'i' );
var regexUrl = new RegExp( '^.+?\.revver\.com\/video/([0-9]+?)/.+?$' );
if( vid_code.match( regex ) ) {
	return '[video:revver:'+vid_code.replace( regex, '$3 w:$1 h:$2' )+']';
} else if( vid_code.match( regexScript ) ) {
	return '[video:revver:'+vid_code.replace( regexScript, '$1 w:$2 h:$3' )+']';
} else if( vid_code.match( regexUrl ) ) {
	return '[video:revver:'+vid_code.replace( regexUrl, '$1' )+']';
} else {
	return false;
}
JAVASCRIPT;

		return $r;
	}


	/**
	 * supports RenderItemAsHtml() in _video.plugin.php
	 */
	function RenderContent( $content, $width )
	{
		if( strpos($content,'[video:revver') !== false )
		{
			$content = preg_replace( '#\[video:revver:(.+?)( w:([0-9]+?) h:([0-9]+?))?]#', '<div class="videoblock"><object type="application/x-shockwave-flash" data="http://flash.revver.com/player/1.0/player.swf?mediaId=\\1" [rvvr:392]><param name="movie" value="http://flash.revver.com/player/1.0/player.swf?mediaId=\\1" /><param name="allowfullscreen" value="true" /><param name="wmode" value="transparent" /></object></div>', $content );
			$content = preg_replace( '#\[rvvr:(.+?)]#', 'width="'.$width.'" height="'.round( ( $width * substr($content,strpos($content,'[rvvr')+6,3) ) / 480 ).'"', $content );
		}
		return $content;
	}
}
?>
