<?php
/**
 * This file implements the TheOnion Video class of the video plugin for Quam Plures
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2010 by the Quam Plures developers - {@link http://quamplures.net/}
 *
 * @package plugins
 * @subpackage Video
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * TheOnion Video Class
 *
 * @package plugins
 * @subpackage Video
 */
class vp_theonion extends vp_video {

	var $nice_name = 'The Onion';
	var $homepage = 'http://theonion.com';
	var $def_value = 0;


	/**
	 * source-specific javascript
	 */
	function GetJavascript()
	{

		/**
		 * Sample embed :
		 * <object width="480" height="430"><param name="allowfullscreen" value="true" /><param name="allowscriptaccess" value="always" /><param name="movie" value="http://www.theonion.com/content/themes/common/assets/onn_embed/embedded_player.swf?image=http%3A%2F%2Fwww.theonion.com%2Fcontent%2Ffiles%2Fimages%2FDENMARK_TOURISM_ARTICLE_2_22.jpg&videoid=100929&title=Denmark%20Introduces%20Harrowing%20New%20Tourism%20Ads%20Directed%20By%20Lars%20Von%20Trier" /><param name="wmode" value="transparent" /><embed src="http://www.theonion.com/content/themes/common/assets/onn_embed/embedded_player.swf"type="application/x-shockwave-flash" allowScriptAccess="always" allowFullScreen="true" wmode="transparent" width="480" height="430"flashvars="image=http%3A%2F%2Fwww.theonion.com%2Fcontent%2Ffiles%2Fimages%2FDENMARK_TOURISM_ARTICLE_2_22.jpg&videoid=100929&title=Denmark%20Introduces%20Harrowing%20New%20Tourism%20Ads%20Directed%20By%20Lars%20Von%20Trier"></embed></object><br /><a href="http://www.theonion.com/content/video/denmark_introduces_harrowing_new?utm_source=videoembed">Denmark Introduces Harrowing New Tourism Ads Directed By Lars Von Trier</a>
		 *
		 *
		 */
		$r = <<<JAVASCRIPT
var regex = new RegExp( '^.+?width="([0-9]+?)" height="([0-9]+?)".+?www\.theonion\.com\/.+?videoid=([0-9]+?)&.+?$', 'i' );
if( vid_code.match( regex ) ) {
	return '[video:theonion:'+vid_code.replace( regex, '$3 w:$1 h:$2' )+']';
} else {
	return false;
}
JAVASCRIPT;
		return $r;
	}


	/**
	 * supports RenderItemAsHtml() in _video.plugin.php
	 */
	function RenderContent( $content, $width )
	{
		if( strpos($content,'[video:theonion') !== false )
		{
			$content = preg_replace( '#\[video:theonion:(.+?) w:([0-9]+?) h:([0-9]+?)]#', '<div class="videoblock">
<object width="$2" height="$3" type="application/x-shockwave-flash" data="http://www.theonion.com/content/themes/common/assets/onn_embed/embedded_player.swf?videoid=$1">
<param name="movie" value="$1" />
<param name="allowFullScreen" value="true" />
<param name="wmode" value="transparent" />
<param name="bgColor" value="#ffffff" />
</object></div>', $content );
		}
		return $content;
	}
}
?>
