<?php
/**
 * This is the template that displays the links to the latest comments for a blog
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 *
 * @package templates
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

$CommentList = new CommentList( $Blog, "'comment','trackback'", array('published'), '', '', 'DESC', '', 20 );

// display a message if list is empty
$CommentList->display_if_empty( array() );

while( $Comment = & $CommentList->get_next() )
{ // Loop through comments:
	// Load comment's Item object:
	$Comment->get_Item();
	$Comment->anchor(); // display an anchor for for this comment
	?>

	<div class="bComment">
	<h3 class="bTitle">
	<?php
	echo T_('In response to').':';

	$Comment->Item->title( array(
		'link_type' => 'permalink',
	) );
	?>
	</h3>

	<div class="bCommentTitle">
	<?php
	// display comment author's name
	$Comment->author( array() );

	// display a link to comment author's URL
	$Comment->author_url( array(
		'before' => ' &middot; '
	) );
	?>
	</div>

	<div class="bCommentText">
	<?php $Comment->content(); // display the comment's contents ?>
	</div>

	<div class="bCommentSmallPrint">
	<?php
	// display a permalink link to the comment
	$Comment->permanent_link( array(
		'class' => 'permalink_right',
		'nofollow' => true,
	) );

	// display the comment's date
	$Comment->date( array(
		'after' => ' @ ',
	) );

	// display the comment's time
	$Comment->time( array(
		'format' => 'H:i',
	) );

	// display a link to edit a comment
	$Comment->edit_link( array(
		'before' => ' &middot; ',
	) );

	// display a link to delete a comment
	$Comment->delete_link( array(
		'before' => ' &middot; ',
	) );
	?>
	</div>

	</div>
	<?php
} // End of comment loop.
?>
