<?php
/**
 * "item comment" sub-template

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This is meant to be included via a .main.php (or other .inc.php) file
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 * @package templates
 * @subpackage generics
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

// set some default params...
$params = array_merge( array(
	'comment_start' => '<div class="bComment">',
	'comment_end' => '</div>',
	'Comment' => NULL, // this object MUST be passed as a param!
), $params );

/**
 * @var Comment
 */
$Comment = & $params['Comment'];
$Comment->anchor(); // display an anchor for for this comment
echo $params['comment_start'];
?>

<div class="bCommentTitle">
<?php
switch( $Comment->get( 'type' ) )
{
	case 'comment':
		if( empty($Comment->ID) )
		{ // PREVIEW comment
			echo T_('PREVIEW Comment from:').' ';
		}
		else
		{
			// display a permalink link to the comment
			$Comment->permanent_link( array(
				'after' => ' '.T_('from:').' ',
				'text' => T_('Comment'),
				'nofollow' => true,
			) );
		}

		// display comment author's name
		$Comment->author( array() );

		// display a link to message form for this comment's author
		$Comment->msgform_link( $Blog->get('msgformurl'), array() );

		// display a link to comment author's URL
		$Comment->author_url( array(
			'before' => ' &middot; '
		) );
		break;

	case 'trackback':
		// display a permalink link to the trackback
		$Comment->permanent_link( array(
			'after' => ' '.T_('from:').' ',
			'text' => T_('Trackback'),
			'nofollow' => true,
		) );

		// display trackback author's name
		$Comment->author( array(
			'make_link' => true
		) );
		break;

}
?>
</div>

<?php
// display a comment's rating
$Comment->rating( array() );
?>

<div class="bCommentText">
<?php $Comment->content(); // display the comment's contents ?>
</div>

<div class="bCommentSmallPrint">
<?php
// display a link to edit a comment
$Comment->edit_link( array(
	'class' => 'permalink_right',
) );

// display a link to delete a comment
$Comment->delete_link( array(
	'class' => 'permalink_right',
) );

// display the comment's date
$Comment->date( array(
	'after' => ' @ ',
) );

// display the comment's time
$Comment->time( array(
	'format' => 'H:i',
) );
?>
</div>

<?php
echo $params['comment_end'];
?>
