<?php
/**
 * default $disp.main.php for the "Asevo" template.

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This file is used to display the content when no $disp-matching .main.php file exists.
 *
 * @copyright {@link http://quamplures.net/team.html The Quam Plures Team, 2010}
 * @license http://quamplures.net/license.html Our License
 * @package templates
 * @subpackage asevo
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_html_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Page Top" container's widgets
template_container( NT_('Page Top'), array(
	'container_start' => '<div class="head_zone"><div class="inner_wrapper"><div class="PageTop">',
	'container_end' => '&nbsp;</div></div></div>',
	'block_display_title' => false,
) );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Menu'), array(
	'container_start' => '<div class="nav_zone"><div class="inner_wrapper"><div class="top_menu"><ul>',
	'container_end' => '</ul>&nbsp;</div></div></div>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );
?>

<div class="main_zone">

<div class="inner_wrapper">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Header" container's widgets
template_container( NT_('Header'), array(
	'container_start' => '<div class="evo_title_area">',
	'container_end' => '</div>',
	'block_title_start' => '<h2>',
	'block_title_end' => '</h2>',
) );
?>

<div class="evo_main_area">
<?php
// messages generated from actions
messages( array() );

// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<table class="prevnext_post"><tr>',
	'prev_start' => '<td>',
	'prev_end' => '</td>',
	'next_start' => '<td class="right">',
	'next_end' => '</td>',
	'block_end' => '</tr></table>',
) );

// title for the current request
request_title( array(
	'title_before' => '<h2 class="evo_req_title">',
	'title_after' => '</h2>',
	'title_single_disp' => false,
) );

// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'featured_post',
	) );
}

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
	) );
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<p class="center"><strong>',
	'block_end' => '</strong></p>',
	'links_format' => '$prev$ :: $next$',
	'prev_text' => '&lt;&lt; '.$Template->T_('Previous'),
	'next_text' => $Template->T_('Next').' &gt;&gt;',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// --- MAIN CONTENT INCLUDED HERE ---
template_include( '$disp$', array(
	// these cases already handled by this file
	'disp_posts' => '',
	'disp_single' => '',
	'disp_page' => '',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Sidebar" container's contents
template_container( NT_('Sidebar'), array(
	'container_start' => '<div class="sidebar">',
	'container_end' => '</div>',
	'block_start' => '<div class="evo_side_item $wi_class$">',
	'block_end' => '</div>',
) );
?>

<div class="clear">
<img src="<?php echo $rsc_url; ?>img/blank.gif" width="1" height="1" alt="" />
</div>

</div>

</div>

<div class="foot_zone">
<div class="inner_wrapper">
<?php
// display the current blog's footer text
$Blog->footer_text( array(
	'before' => '<p class="baseline">',
	'after' => '</p>',
) );
?>
<p class="baseline2">
<?php
// display a link to contact the current blog owner
$Blog->contact_link( array(
	'after' => ' | ',
) );

// display a link to this blog's credits page
$Blog->credits_link( array() );
?>
</p>
</div>
</div>

<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateEndHtmlBody' );
debug_info(); // output debug info if requested
?>
</div>
</body>
</html>
<?php $Hit->log(); // log the hit on this page ?>
