<?php
/**
 * This is the template that displays the software credits page.
 *
 * This file is part of the Quam Plures project - {@link http://quamplures.net/}.
 * See also {@link https://launchpad.net/quam-plures}.
 *
 * @todo EdB: this needs hooks for plugin profile bits
 *
 * @copyright (c) 2010 by the Quam Plures developers - {@link http://quamplures.net/}
 * @license http://quamplures.net/license.html GNU General Public License (GPL)
 * @package templates
 * @subpackage basic
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

// title for the current request
request_title( array(
	'title_before' => '<h2>',
	'title_after' => '</h2>',
) );
?>

<div id="credits">
<dl>

<?php
// First: template credits from the template.class file
if( isset( $Template ) && ( $credits = $Template->get_template_credits() ) )
{
	echo '<dt>'.$Template->T_('Template Credits').':</dt>'."\n";
	echo '<dd><dl>', "\n";

	foreach( $credits as $linkback )
	{
		echo '<dt>', $linkback['pre'], '</dt>';
		echo '<dd><a href="', $linkback['url'], '" title="';
		echo format_to_output( $linkback['title'], 'htmlattr' ), '">';
		echo format_to_output( $linkback['text'], 'text' ), '</a></dd><dd>';
		echo $linkback['post'], "</dd>\n";
	}

	echo '</dl></dd>', "\n";
}

// Second: plugin credits excluding 'core' plugins
global $Plugins;
$credits = array();

$Plugins->restart();
while( ( $a_plugin = & $Plugins->get_next() ) )
{
	if( empty($a_plugin->name) || $a_plugin->author == 'Dracones Incompertus'
		|| $a_plugin->author == 'The b2evo Group' )
	{ // Skip our own plugins.
		continue;
	}

	$p_name = format_to_output( $a_plugin->name, 'htmlbody' );
	if( $a_plugin->help_url != '' )
	{
		$p_name = '<a href="'.$a_plugin->help_url.'" title="'.T_('visit this plugins web page').'">'.$p_name.'</a>';
	}

	$a_name = format_to_output( $a_plugin->author, 'htmlbody' );
	if( $a_plugin->author_url != '' )
	{
		$a_name = '<a href="'.$a_plugin->author_url.'" title="'.T_('visit the authors website').'">'.$a_name.'</a>';
	}

	$credits[ strtolower( $a_plugin->name ) ] = array(
		'p_name' => $p_name,
		'a_name' => $a_name,
		'desc' => $a_plugin->short_desc,
	);
}

if( !empty( $credits ) )
{
	ksort( $credits );
	echo '<dt>'.T_('Plugin Credits').':</dt>'."\n";
	echo '<dd><dl>'."\n";

	foreach( $credits as $credit )
	{
		echo '<dt>'.$credit['p_name'].' '.T_('by').' '.$credit['a_name'].'</dt><dd>'.$credit['desc']."</dd>\n";
	}

	echo '</dl></dd>'."\n";
}

// Third: core contributor credits
global $templates_path;
/**
 * Load the list of contributors for this version.
 */
require_once $templates_path.'/_contributors.php'; // contributors links

echo '<dt>'.$Template->T_('Core Contributors').':</dt>'."\n";
echo '<dd><dl>', "\n";

foreach( $_hic_sunt_dracones as $dracone )
{
	echo '<dt><a href="', $dracone['homepage'], '" title="';
	echo format_to_output( $dracone['homepage'], 'htmlattr' ), '">';
	echo format_to_output( $dracone['name'], 'text' ), '</a></dt><dd>';
	locale_flag( $dracone['locale'], 'h10px', 'leftmargin' );
	echo $dracone['spiel']."</dd>\n";
}

echo '</dl></dd>', "\n";

// Finally: QP's only linkback
if( isset( $Template ) )
{
	echo '<dt>'.$Template->poweredby_linkback['pre'].':</dt>'."\n";
	echo '<dd><dl>', "\n";
	echo '<dt><a href="', $Template->poweredby_linkback['url'], '" title="';
	echo format_to_output( $Template->poweredby_linkback['title'], 'htmlattr' ), '">';
	echo format_to_output( $Template->poweredby_linkback['text'], 'text' ), '</a></dt><dd>';
	echo $Template->poweredby_linkback['post'], "</dd>\n";
	echo '</dl></dd>', "\n";
}

?>

</dl>
</div>
