<?php
/**
 * "item feedback" sub-template

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This is meant to be included via a .main.php (or other .inc.php) file
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 * @package templates
 * @subpackage basic
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

global $params, $c, $tb;

if( ! $Item->can_see_comments() )
{ // Comments are disabled for this post
	return;
}

$disp_comments = $disp_comment_form = $disp_trackbacks = $disp_trackback_url = true;

if( empty($c) )
{ // Comments not requested
	$disp_comments = false;
	$disp_comment_form = false;
}

if( empty($tb) || !$Blog->get( 'allowtrackbacks' ) )
{ // Trackback not requested or not allowed
	$disp_trackbacks = false;
	$disp_trackback_url = false;
}

if( ! ($disp_comments || $disp_comment_form || $disp_trackbacks || $disp_trackback_url ) )
{ // Nothing more to do....
	return false;
}

echo '<a id="feedbacks"></a>';

$type_list = array();
$disp_title = array();

// We requested to display comments?
if( $disp_comments )
{
	if( $Item->can_see_comments() )
	{
		$type_list[] = "'comment'";
		if( $title = $Item->get_feedback_title( 'comments' ) )
		{
			$disp_title[] = $title;
		}
	}
	else
	{
		$disp_comments = false;
	}
	echo '<a id="comments"></a>';
}

// We requested to display trackbacks?
if( $disp_trackbacks )
{
	$type_list[] = "'trackback'";
	if( $title = $Item->get_feedback_title( 'trackbacks' ) )
	{
		$disp_title[] = $title;
	}
	echo '<a id="trackbacks"></a>';
}

// We want to display the trackback URL?
if( $disp_trackback_url )
{
	echo '<h3>'.$Template->T_('Trackback address for this post').'</h3>';
	// Trigger plugin event ... 
	if( ! $Plugins->trigger_event_first_true( 'DisplayTrackbackAddr', array('Item' => & $Item, 'template' => '<code>%url%</code>') ) )
	{
		// if no plugin displayed a payload we just display the default
		echo '<p class="trackback_url"><a href="'.$Item->get_trackback_url().'">'.$Template->T_('Trackback URL (right click and copy shortcut/link location)').'</a></p>';
	}
}

// if we have something to display ...
if( $disp_comments || $disp_trackbacks )
{
	// ... first we make a title ...
	if( empty($disp_title) )
	{
		if( $title = $Item->get_feedback_title( 'feedbacks', '', $Template->T_('Feedback awaiting moderation'), $Template->T_('Feedback awaiting moderation'), 'draft' ) )
		{
			$disp_title[] = $title;
		}
	}
	// still no title?
	if( empty($disp_title) )
	{ 
		$disp_title[] = $Template->T_('No feedback yet');
	}

	// show the title :)
	echo '<h3>'.implode( ', ', $disp_title).'</h3>';

	// spark off a comment list...
	$CommentList = new CommentList( NULL, implode(',', $type_list), array('published'), $Item->ID, '', 'ASC' );

	// loop through comments...
	while( $Comment = & $CommentList->get_next() )
	{
		// --- --- --- --- --- --- --- --- --- --- ---
		// --- A SINGLE COMMENT INCLUDED HERE ---
		template_include( '_item_comment.inc.php', array(
			'Comment' => & $Comment,
			'comment_start' => '<div class="comment_start">',
			'comment_end' => '</div>',
		) );
	}

	// display count of comments to be moderated
	$Item->feedback_moderation( 'feedbacks', '<div class="moderation_msg"><p>', '</p></div>', '',
		$Template->T_('This post has 1 feedback awaiting moderation... %s'),
		$Template->T_('This post has %d feedbacks awaiting moderation... %s') );

	// display link for comments feed?
	if( $Blog->get_setting( 'feed_content' ) != 'none' ) 
	{
		$Item->feedback_feed_link( '_rss2', '<div class="feedback_feed_msg"><p>', '</p></div>' );
	}

}

// --- --- --- --- --- --- --- --- --- --- ---
// --- COMMENT FORM INCLUDED HERE ---
template_include( '_item_comment_form.inc.php', $params );
?>
