<?php
/**
 * default $disp.main.php for the "Basic" template.

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This file is used to display the content when no $disp-matching .main.php file exists.
 *
 * @author Your Name <spam-me@domain.tld>
 * @author {@link http://domain.tld/ Your Name linked to your domain}
 *
 * @copyright {@link http://quamplures.net/team.html The Quam Plures Team, 2010}
 * @license http://quamplures.net/license.html Our License
 * @package templates
 * @subpackage basic
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_html_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Page Top" container's widgets
template_container( NT_('Page Top'), array() );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Header" container's widgets
template_container( NT_('Header'), array() );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Menu'), array(
	'container_start' => '<div id="Menu"><ul>',
	'container_end' => '</ul></div>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );
?>

<div id="main_content">
<?php
// messages generated from actions
messages( array() );

// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<div class="item_prevnext_links">',
	'block_end' => '</div>',
) );

// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php' );
}

// prev/next links on multi-post pages
mainlist_page_links();

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	$Item->locale_temp_switch(); // temporarily switch to item's locale

	// display the date if it changed
	$MainList->date_if_changed( array() );

	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php' );

	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM FEEDBACK INCLUDED HERE ---
	template_include( '_item_feedback.inc.php' );

	locale_restore_previous(); // restores previous locale

}

// --- --- --- --- --- --- --- --- --- --- ---
// --- MAIN CONTENT INCLUDED HERE ---
template_include( '$disp$', array(
	// these cases already handled by this file
	'disp_posts' => '',
	'disp_single' => '',
	'disp_page' => '',
) );

// prev/next links on multi-post pages
mainlist_page_links( array() );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Sidebar" container's contents
template_container( NT_('Sidebar'), array() );
?>

<div id="Footer">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Footer" container's contents
template_container( NT_('Footer'), array() );
?>
<p>
<?php
user_login_link();
user_register_link();
user_admin_link();
user_logout_link();

// display a link to contact the current blog owner
$Blog->contact_link( array() );

// display a link to this blog's credits page
$Blog->credits_link( array() );
?>
</p>
</div>

<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateEndHtmlBody' );
debug_info(); // output debug info if requested
?>
</div>
</body>
</html>
<?php $Hit->log(); // log the hit on this page ?>
