<?php
/**
 * Template Class file
 *
 * This file is part of the Quam Plures project - {@link http://quamplures.net/}
 *
 * @package templates
 * @subpackage evocamp
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * template class
 *
 * @package templates
 * @subpackage evocamp
 */
class evocamp_Template extends Template
{

	/**
	 * Get default name for the template, which the admin can customize.
	 */
	function get_default_name()
	{
		return 'Evocamp';
	}


	/**
	 * Get default type for the template.
	 */
	function get_default_type()
	{
		return 'normal';
	}


	/**
	 * Get credits for linkback on credits page.
	 * see http://docs.quamplures.net/templates/Template.html#methodget_template_credits
	 */
	function get_template_credits()
	{
		$template_linkbacks = array(
			'designer' => array(
				'pre' => $this->T_('Design by'),
				'text' => 'solostream',
				'post' => '', /* Replace with $this->T_('...') when there is something to translate */
				'url' => 'http://www.solostream.com/',
				'title' => 'http://www.solostream.com/',
			),
			'ported' => array(
				'pre' => $this->T_('Ported by'),
				'text' => 'EdB',
				'post' => '', /* Replace with $this->T_('...') when there is something to translate */
				'url' => 'http://1912webworks.com/',
				'title' => $this->T_('insert creative link title'),
			),
		);
		return $template_linkbacks;
	}

}

?>
