<?php
/**
 * posts.main.php for the "Evopress" template.

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This file is used to display the content when $disp == 'posts'. A template
 * without this file will use index.main.php by default.
 *
 * @copyright {@link http://quamplures.net/team.html The Quam Plures Team, 2010}
 * @license http://quamplures.net/license.html Our License
 * @package templates
 * @subpackage evopress
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_html_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY HEADER INCLUDED HERE ---
template_include( '_body_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Menu'), array(
	'container_start' => '<div class="top_menu top_menu_narrow"><ul>',
	'container_end' => '</ul></div>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );
?>

<div id="content" class="narrowcolumn">
<?php
// messages generated from actions
messages( array() );

// title for the current request
request_title( array(
	'title_before' => '<h2>',
	'title_after' => '</h2>',
) );

// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'featured_post',
	) );
}

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
	) );
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<div class="navigation">',
	'block_end' => '</div>',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- SIDEBAR INCLUDED HERE ---
template_include( '_sidebar.inc.php', array() );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY FOOTER INCLUDED HERE ---
template_include( '_body_footer.inc.php' );
?>
