<?php
/**
 * single.main.php for the "Evopress" template.

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This file is used to display the content when $disp == 'single'. A template
 * without this file will use index.main.php by default.
 *
 * @copyright {@link http://quamplures.net/team.html The Quam Plures Team, 2010}
 * @license http://quamplures.net/license.html Our License
 * @package templates
 * @subpackage evopress
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

template_init( $disp ); // do $disp-based initializations...

add_headline( <<<HEREDOC
<style type="text/css" media="screen">
	#page { background: url("img/kubrickbgwide.jpg") repeat-y top; }
</style>
HEREDOC
);

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_html_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY HEADER INCLUDED HERE ---
template_include( '_body_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Menu'), array(
	'container_start' => '<div class="top_menu"><ul>',
	'container_end' => '</ul></div>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );
?>

<div id="content" class="widecolumn">
<?php
// messages generated from actions
messages( array() );

// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<table class="prevnext_post"><tr>',
	'prev_start' => '<td>',
	'prev_end' => '</td>',
	'next_start' => '<td class="right">',
	'next_end' => '</td>',
	'block_end' => '</tr></table>',
) );

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	$Item->locale_temp_switch(); // temporarily switch to item's locale
	?>

	<div id="<?php $Item->anchor_id(); ?>" class="post post<?php $Item->status_raw(); ?>" lang="<?php $Item->lang(); ?>">
	<?php
	// display and link item title
	$Item->title( array(
		'before' => '<h2>',
		'after' => '</h2>',
	) );

	// --- --- --- --- --- --- --- --- --- --- ---
	// --- POST CONTENT INCLUDED HERE ---
	template_include( '_item_content.inc.php', array(
		'image_size' => 'fit-440',
	) );
	?>
	<p class="postmetadata alt"><small><?php
	// display issue date/time of item
	$Item->issue_date( array(
		'before' => /* TRANS: date */ $Template->T_('This entry was posted on').' ',
		'date_format' => 'F jS, Y',
	) );

	// display issue date/time of item
	$Item->issue_time( array(
		'before' => /* TRANS: time */ $Template->T_('at').' ',
	) );

	// display author/creator of item
	$Item->author( array(
		'before' => $Template->T_('by').' ',
	) );

	// display and link categories by name
	$Item->categories( array(
		'before' => $Template->T_('and is filed under').' ',
		'after' => '.',
	) );

	// display the item's tags
	$Item->tags( array(
		'before' => ' '.$Template->T_('Tags').': ',
		'after' => ' ',
	) );

	// display link to edit this item
	$Item->edit_link( array(
		'after' => '',
	) );
	?></small></p>
	</div>

	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM FEEDBACK INCLUDED HERE ---
	template_include( '_item_feedback.inc.php', array(
		'before_section_title' => '<h3>',
		'after_section_title' => '</h3>',
	) );

	locale_restore_previous(); // restores previous locale

}
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY FOOTER INCLUDED HERE ---
template_include( '_body_footer.inc.php' );
?>
