<?php
/**
 * single.main.php for the "Glossy Blue" template.

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This file is used to display the content when $disp == 'single'. A template 
 * without this file will use index.main.php by default.
 *
 * @copyright {@link http://quamplures.net/team.html The Quam Plures Team, 2010}
 * @license http://quamplures.net/license.html Our License
 * @package templates
 * @subpackage glossyblue
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_html_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY HEADER INCLUDED HERE ---
template_include( '_body_header.inc.php' );
?>

<div id="content">
<?php
// messages generated from actions
messages( array() );

// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<table class="prevnext_post"><tr>',
	'prev_start' => '<td>',
	'prev_end' => '</td>',
	'next_start' => '<td class="right">',
	'next_end' => '</td>',
	'block_end' => '</tr></table>',
) );

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	$Item->locale_temp_switch(); // temporarily switch to item's locale
	$Item->anchor(); // displays anchor for permalinks
	?>

	<div id="post-<?php $Item->ID(); ?>" class="post post<?php $Item->status_raw(); ?>" lang="<?php $Item->lang(); ?>">

	<div class="post-date">
	<?php
	// display issue date/time of item
	$Item->issue_date( array(
		'before' => '<span class="post-month">',
		'after' => '</span>',
		'date_format' => 'M',
	) );

	// display issue date/time of item
	$Item->issue_date( array(
		'before' => '<span class="post-day">',
		'after' => '</span>',
		'date_format' => 'd',
	) );
	?>
	</div>

	<div class="post-title">
	<?php
	// display and link item title
	$Item->title( array(
		'before' => '<h2>',
		'after' => '</h2>',
	) );

	// display and link categories by name
	$Item->categories( array(
		'before' => '<span class="post-cat">',
		'after' => '</span> ',
	) ); ?>
	<span class="mini-add-comment"><?php
	// display link to (and count of) comments and trackbacks
	$Item->feedback_link( array(
		'link_text_zero' => $Template->T_('Add comments'),
		'link_text_one' => $Template->T_('Add comments'),
		'link_text_more' => $Template->T_('Add comments'),
	) ); ?></span>
	</div>

	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- POST CONTENT INCLUDED HERE ---
	template_include( '_item_content.inc.php', array() );
	?>
	<p class="postmetadata alt small">
	<?php
	// display the item's tags
	$Item->tags( array(
		'before' => ' '.$Template->T_('Tags').': ',
		'after' => ' ',
	) );

	// display link to edit this item
	$Item->edit_link( array(
		'after' => '',
	) );
	?>
	</p>
	</div>

	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM FEEDBACK INCLUDED HERE ---
	template_include( '_item_feedback.inc.php', array(
		'before_section_title' => '<h3>',
		'after_section_title' => '</h3>',
	) );

	locale_restore_previous(); // restores previous locale

}
?>

</div>
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- SIDEBAR INCLUDED HERE ---
template_include( '_sidebar.inc.php', array() );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY FOOTER INCLUDED HERE ---
template_include( '_body_footer.inc.php' );
?>
