<?php
/**
 * "item block" sub-template

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This is meant to be included via a .main.php (or other .inc.php) file
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 * @package templates
 * @subpackage intense
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'post',
), $params );
?>

<div id="<?php $Item->anchor_id(); ?>" class="<?php $Item->div_classes( $params ); ?>" lang="<?php $Item->lang(); ?>">

<?php
$Item->locale_temp_switch(); // temporarily switch to item's locale

if( $Item->is_intro() )
{
	// display link to edit this item
	$Item->edit_link( array(
		'before' => '<div>',
		'after' => '</div>',
	) );
}

// display and link item title
$Item->title( array(
	'before' => '<h2 class="post-title">',
	'after' => '</h2>',
) );

if( ! $Item->is_intro() )
{
	// display issue date/time of item
	$Item->issue_time( array(
		'before' => '<small>',
		'after' => '</small>',
		'time_format' => 'F jS, Y',
	) );
}

// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', array() );

// display the item's tags
$Item->tags( array(
	'before' => '<div class="posttags">'.$Template->T_('Tags').': ',
) );

if( ! $Item->is_intro() )
{
	?>
	<p class="postmetadata">
	<?php
	// display and link categories by name
	$Item->categories( array(
		'before' => $Template->T_('Posted in').' ',
	) );

	// display link to edit this item
	$Item->edit_link( array(
		'before' => ' | ',
		'after' => '',
	) );

	// display link to (and count of) comments and trackbacks
	$Item->feedback_link( array(
		'link_before' => ' | ',
	) );
	?></p>
	<?php
}
?>
</div>

<?php
locale_restore_previous(); // restores previous locale
?>
