<?php
/**
 * Template Class file
 *
 * This file is part of the Quam Plures project - {@link http://quamplures.net/}
 *
 * @package templates
 * @subpackage intense
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * template class
 *
 * @package templates
 * @subpackage intense
 */
class intense_Template extends Template
{

	/**
	 * Get default name for the template, which the admin can customize.
	 */
	function get_default_name()
	{
		return 'Intense';
	}


	/**
	 * Get default type for the template.
	 */
	function get_default_type()
	{
		return 'normal';
	}


	/**
	 * Get definitions for editable params
	 *
	 * @see Plugin::GetDefaultSettings()
	 */
	function get_param_definitions( $params )
	{
		$r = array_merge( array(
				'head_image' => array(
					'label' => $this->T_('Header Image'),
					'note' => $this->T_('0 for random header image; 1,2,3,4 for custom header image.'),
					'defaultvalue' => 0,
					'valid_pattern' => array(
						'pattern' =>'^([0-4]{1})?$', 'error' =>T_('Invalid Header Image.'),
					),
				)
			), parent::get_param_definitions( $params )	);
		return $r;
	}


	/**
	 * Get ready for displaying the skin.
	 *
	 * This may register some CSS or JS...
	 */
	function display_init()
	{
		// call parent:
		parent::display_init();
	}


	/**
	 * Get credits for linkback on credits page.
	 * see http://docs.quamplures.net/templates/Template.html#methodget_template_credits
	 */
	function get_template_credits()
	{
		$template_linkbacks = array(
			'designer' => array(
				'pre' => $this->T_('Design by'),
				'text' => 'Salted Sugar',
				'post' => '', /* Replace with $this->T_('...') when there is something to translate */
				'url' => 'http://saltedsugar.com/',
				'title' => 'http://saltedsugar.com/',
			),
			'ported' => array(
				'pre' => $this->T_('Ported by'),
				'text' => 'EdB',
				'post' => '', /* Replace with $this->T_('...') when there is something to translate */
				'url' => 'http://1912webworks.com/',
				'title' => $this->T_('insert creative link title'),
			),
		);
		return $template_linkbacks;
	}

}

?>
