<?php
/**
 * "item block" sub-template

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This is meant to be included via a .main.php (or other .inc.php) file
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 * @package templates
 * @subpackage miami_blue
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'bPost',
	'item_status_class' => 'bPost',
	'image_size' => 'fit-440',
	'image_link_to' => 'single',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<div id="<?php $Item->anchor_id(); ?>" class="<?php $Item->div_classes( $params ); ?>" lang="<?php $Item->lang(); ?>">
<?php
// display and link item title
$Item->title( array(
	'before' => '<h2 class="bTitle">',
	'after' => '</h2>',
) );
?>

<div class="bSmallHead">
<?php
// display issue date/time of item
$Item->issue_date( array(
	'before' => ' ',
) );

// display author/creator of item
$Item->author( array(
	'before' => ' | '.$Template->T_('by').' <strong>',
	'after' => '</strong>',
) );

// display message form link to item's author
$Item->msgform_link( array(
	'before' => ' ',
	'text' => '<img src="img/envelope.gif" alt="[mail]" width="13" height="10" class="middle" />',
) );

// display and link categories by name
$Item->categories( array(
	'before' => ' | '.$Template->T_('Categories').': ',
	'before_main' => '<strong>',
	'after_main' => '</strong>',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );

// display the item's tags
$Item->tags( array(
	'before' => '<div class="">'.$Template->T_('Tags').': ',
) );
?>

<div class="bSmallPrint">
<?php
// display link to (and count of) comments and trackbacks
$Item->feedback_link( array(
	'link_after' => ' &bull; ',
) );

// display link to edit this item
$Item->edit_link( array(
	'after' => ' &bull; ',
) );

// display the item's permalink
$Item->permanent_link( array(
	'text' => '<img src="img/page.gif" alt="'.$Template->T_('Permalink').'" width="9" height="12" class="middle" />',
) );
?>
</div>

<img src="img/blank.gif" width="1" height="1" alt="" />
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- ITEM FEEDBACK INCLUDED HERE ---
template_include( '_item_feedback.inc.php', array(
	'before_section_title' => '<h4>',
	'after_section_title' => '</h4>',
) );

locale_restore_previous(); // restores previous locale
?>
</div>
