<?php
/**
 * default $disp.main.php for the "Nifty Corners" template.

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This file is used to display the content when no $disp-matching .main.php file exists.
 *
 * @copyright {@link http://quamplures.net/team.html The Quam Plures Team, 2010}
 * @license http://quamplures.net/license.html Our License
 * @package templates
 * @subpackage nifty_corners
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

template_init( $disp ); // do $disp-based initializations...

// Initializations:
require_css( 'rsc/nifty_corners.css', true, 'Nifty Corners' );
require_css( 'rsc/nifty_print.css', true, 'Print', 'print' );
require_js( 'rsc/nifty_corners.js', true );
$custom_js = <<<HEREDOC
	<script type="text/javascript">
	<!--
	window.onload=function()
	{
		if(!NiftyCheck())
			return;
		Rounded("div.outerwrap","all","transparent","#fff","");
		Rounded("div.posts","all","transparent","#fff","");
		Rounded("div.bSideBar","all","transparent","#fff","");
		Rounded("div.bTitle","top","#fff","#06a3c4","smooth");
	}
	// -->
	</script>
HEREDOC;
add_headline( $custom_js );

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_html_header.inc.php' );
?>

<div class="wrapper">

<div class="wrapper2">

<div class="outerwrap">
<div class="innerwrap">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Page Top" container's widgets
template_container( NT_('Page Top'), array(
	'container_start' => '<div id="PageTop">',
	'container_end' => '</div>',
	'block_display_title' => false,
) );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Header" container's widgets
template_container( NT_('Header'), array(
	'container_start' => '<div class="pageHeader">',
	'container_end' => '</div>',
	'block_title_start' => '<h1>',
	'block_title_end' => '</h1>',
) );
?>
</div>
</div>

<div class="posts">
<div class="innerwrap">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Menu'), array(
	'container_start' => '<div class="top_menu"><ul>',
	'container_end' => '</ul></div>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );

// messages generated from actions
messages( array() );

// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<table class="prevnext_post"><tr>',
	'prev_start' => '<td>',
	'prev_end' => '</td>',
	'next_start' => '<td class="right">',
	'next_end' => '</td>',
	'block_end' => '</tr></table>',
) );

// title for the current request
request_title( array(
	'title_before' => '<h2>',
	'title_after' => '</h2>',
) );

// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'featured_post',
	) );
}

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// display the date if it changed
	$MainList->date_if_changed( array() );

	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
	) );

}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<p class="center"><strong>',
	'block_end' => '</strong></p>',
	'links_format' => '$prev$ :: $next$',
	'prev_text' => '&lt;&lt; '.$Template->T_('Previous'),
	'next_text' => $Template->T_('Next').' &gt;&gt;',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// --- MAIN CONTENT INCLUDED HERE ---
template_include( '$disp$', array(
	// these cases already handled by this file
	'disp_posts' => '',
	'disp_single' => '',
	'disp_page' => '',
) );
?>
</div>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Sidebar" container's contents
template_container( NT_('Sidebar'), array(
	'container_start' => '<div class="bSideBar"><div class="innerwrap">',
	'container_end' => '</div></div>',
	'block_start' => '<div class="bSideItem $wi_class$">',
	'block_end' => '</div>',
) );
?>

<div class="clear"><img src="<?php echo $rsc_url; ?>img/blank.gif" width="1" height="1" alt="" /></div>

</div>

<div id="pageFooter">
<p class="baseline">
<?php
// display a link to contact the current blog owner
$Blog->contact_link( array(
	'after' => ' &bull; ',
) );

// display the current blog's footer text
$Blog->footer_text( array(
	'before' => ' ',
) );
?>
<br />
<?php
// display a link to this blog's credits page
$Blog->credits_link( array() );
?>
</p>
</div>

</div>

<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateEndHtmlBody' );
debug_info(); // output debug info if requested
?>
</div>
</body>
</html>
<?php $Hit->log(); // log the hit on this page ?>
