<?php
/**
 * "html header" sub-template

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This is meant to be included via a .main.php (or other .inc.php) file
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 * @package templates
 * @subpackage photoblog
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

global $srvc_url;

add_js_for_toolbar(); // registers javascripts for the navbar
if( $disp == '404' )
{
	header('HTTP/1.0 404 Not Found');
}
header_content_type(); // sets charset
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php locale_lang(); ?>" lang="<?php locale_lang(); ?>">
<head>
<?php
template_content_meta(); // Content-Type meta tag
template_base_tag(); // for css and img includes
// spark the plugin manager
$Plugins->trigger_event( 'TemplateBeginHtmlHead' );
?>
<title><?php // title for the current request
request_title( array(
	'auto_pilot' => 'seo_title',
	'arcdir_text' => $Template->T_('Index'),
	'catdir_text' => $Template->T_('Albums'),
	'category_text' => $Template->T_('Album').': ',
	'categories_text' => $Template->T_('Albums').': ',
) ); ?></title>
<?php
template_description_tag(); // description meta tag
template_keywords_tag(); // keywords meta tag
robots_tag(); // robots meta tag
meta_generator_tag(); // for QP's stats
if( $Blog->get_setting( 'feed_content' ) != 'none' )
{ // auto-discovery urls
	?>
	<link rel="alternate" type="application/rss+xml" title="RSS 2.0" href="<?php $Blog->disp( 'rss2_url', 'raw' ) ?>" />
	<link rel="alternate" type="application/atom+xml" title="Atom" href="<?php $Blog->disp( 'atom_url', 'raw' ) ?>" />
	<?php
}
?>
<link rel="EditURI" type="application/rsd+xml" title="RSD" href="<?php echo $srvc_url; ?>rsd.php?blog=<?php echo $Blog->ID; ?>" />
<meta name="viewport" content="width = 750" />
<link rel="stylesheet" type="text/css" href="style.css" media="screen" />
<link rel="stylesheet" type="text/css" href="print.css" media="print" />
<?php
include_headlines(); // output collected <head> lines
$Blog->disp( 'blog_css', 'raw'); // blog-specific css tweaks, if allowed
$Blog->disp( 'user_css', 'raw'); // user-specific css tweaks, if allowed
?>
</head>

<body>
<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateBeginHtmlBody' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- TOOLBAR INCLUDED HERE ---
template_include( '_toolbar.inc.php' );

echo "\n";
if( is_logged_in() )
{
	echo '<div id="template_wrapper" class="template_wrapper_loggedin">';
}
else
{
	echo '<div id="template_wrapper" class="template_wrapper_anonymous">';
}
echo "\n";
?>