<?php
/**
 * "item block" sub-template

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This is meant to be included via a .main.php (or other .inc.php) file
 *
 * Quam Plures - {@link http://quamplures.net/}
 * Released under GNU GPL License - {@link http://quamplures.net/license.html}
 * @copyright (c) 2009 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}
 * @package templates
 * @subpackage pixelgreen
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'post',
	'item_status_class' => 'bPost',
	'image_size' => 'fit-440',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<div id="<?php $Item->anchor_id(); ?>" class="<?php $Item->div_classes( $params ); ?>" lang="<?php $Item->lang(); ?>">
<?php
// display and link item title
$Item->title( array(
	'before' => '<h3 class="bTitle">',
	'after' => '</h3>',
) );
?>
<p>
<?php
// display author/creator of item
$Item->author( array(
	'before' => $Template->T_('by').' <strong>',
	'after' => '</strong>',
) );

// display message form link to item's author
$Item->msgform_link( array(
	'before' => ' ',
	'after' => '',
) );
?>
</p>
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );
?>

<div class="post-footer">

<div class="bSmallHead">
<?php
// display and link categories by name
$Item->categories( array(
	'before' => $Template->T_('Categories').': ',
) );

// display the item's tags
$Item->tags( array(
	'before' => $Template->T_('Tags').': ',
	'after' => '<br />',
) );

// display the item's permalink
$Item->permanent_link( array(
	'class' => 'permalink_right',
	'text' => '#icon#'
) );

// display issue date/time of item
$Item->issue_date( array(
	'before' => '<img src="img/clock.gif" alt="" class="middle" />',
) );

// display issue date/time of item
$Item->issue_time( array(
	'after' => '',
) );

echo ', ';

// display link to (and count of) comments only
$Item->feedback_link( array(
	'type' => 'comments',
	'link_before' => '<img src="img/comment.gif" alt="" class="middle" />',
) );

// display link to (and count of) trackbacks only
$Item->feedback_link( array(
	'type' => 'trackbacks',
	'link_before' => ' &bull; ',
) );

// display link to edit this item
$Item->edit_link( array(
	'before' => ' &bull; ',
	'after' => '',
) );
?>
</div>

</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- ITEM FEEDBACK INCLUDED HERE ---
template_include( '_item_feedback.inc.php', array(
	'before_section_title' => '<h4>',
	'after_section_title' => '</h4>',
) );

locale_restore_previous(); // restores previous locale
?>
</div>
