<?php
/**
 * default $disp.main.php for the "TerraFirma" template.

Need help doing something with this file?
http://docs.quamplures.net/li_templates.html - tutorials and autodocs

 * This file is used to display the content when no $disp-matching .main.php file exists.
 *
 * @copyright {@link http://quamplures.net/team.html The Quam Plures Team, 2010}
 * @license http://quamplures.net/license.html Our License
 * @package templates
 * @subpackage terrafirma
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_html_header.inc.php' );
?>

<div id="wrapper">

<div id="upbg"></div>

<div id="inner">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Header" container's widgets
template_container( NT_('Header'), array(
	'container_start' => '<div class="pageHeader">',
	'container_end' => '</div>',
	'block_title_start' => '<h1>',
	'block_title_end' => '</h1>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Page Top" container's widgets
template_container( NT_('Page Top'), array(
	'container_start' => '<div id="splash"><div class="PageTop">',
	'container_end' => '</div></div>',
	'block_display_title' => false,
) );
?>

<div class="top_menu">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Menu'), array(
	'container_start' => '<ul>',
	'container_end' => '</ul>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );
?>
</div>

<div class="bPosts">
<?php
// messages generated from actions
messages( array() );

// title for the current request
request_title( array(
	'title_before' => '<h2 class="pagetitle">',
	'title_after' => '</h2>',
	'title_single_disp' => false,
	'title_page_disp' => false,
) );

// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'bPost featured_post',
	) );
}

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
	) );
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<p class="center"><strong>',
	'block_end' => '</strong></p>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// --- MAIN CONTENT INCLUDED HERE ---
template_include( '$disp$', array(
	// these cases already handled by this file
	'disp_posts' => '',
	'disp_single' => '',
	'disp_page' => '',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Sidebar" container's contents
template_container( NT_('Sidebar'), array(
	'container_start' => '<div class="bSideBar">',
	'container_end' => '</div>',
	'block_start' => '<div class="bSideItem $wi_class$">',
	'block_end' => '</div>',
	'block_title_start' => '<h2>',
	'block_title_end' => '</h2>',
) );
?>

<div id="pageFooter">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Footer" container's widgets
template_container( NT_('Footer'), array() );
?>
<p class="baseline">
<span class="author_credits">
<?php
// display a link to contact the current blog owner
$Blog->contact_link( array(
	'after' => '',
) );

// display the current blog's footer text
$Blog->footer_text( array(
	'before' => ' &bull; ',
	'after' => '',
) );
?>
</span>
<br />
<?php
// display a link to this blog's credits page
$Blog->credits_link( array() );
?>
</p>
</div>

</div>

</div>

<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateEndHtmlBody' );
debug_info(); // output debug info if requested
?>
</div>
</body>
</html>
<?php $Hit->log(); // log the hit on this page ?>
